Public Class frm_Plugin_PrivatrechnungBase
    Protected Friend m_Wegegeldeintrag As Wegegeldeintrag

#Region "Constructor "
    Public Overrides Sub DatenUebernahme(ByVal Daten As PlugInUebergabeDaten)
        MyBase.DatenUebernahme(Daten)
        Me.ComboBoxWegegeld.SelectedIndex = 0
        Me.ComboBoxFaktor.SelectedIndex = 1
    End Sub
#End Region

#Region " OKCheck "
    Overrides Function CheckOK() As Boolean
        If MyBase.CheckOK Then
            Try
                Dim Zahl As Decimal = CDec(Me.ComboBoxFaktor.Text)
                Return True
            Catch ex As Exception

            End Try
        End If
        Return False
    End Function

    Overrides Sub MakeOKCheck()

    End Sub
#End Region

    Public Overrides Sub Werte_OhneEventsLesen()
        MyBase.Werte_OhneEventsLesen()
        Wegegeldeintrag_Ermitteln()
    End Sub

#Region " Wegegeld "
    Private Sub Wegegeldeintrag_Ermitteln()
        Select Case Me.ComboBoxWegegeld.SelectedIndex
            Case 0 : m_Wegegeldeintrag = New Wegegeldeintrag("-", 0D)

            Case 1 : m_Wegegeldeintrag = New Wegegeldeintrag("bis 2km am Tag", 3.58D)
            Case 2 : m_Wegegeldeintrag = New Wegegeldeintrag("bis 5km am Tag", 6.65D)
            Case 3 : m_Wegegeldeintrag = New Wegegeldeintrag("bis 10km am Tag", 10.23D)
            Case 4 : m_Wegegeldeintrag = New Wegegeldeintrag("bis 25km am Tag", 15.34D)

            Case 5 : m_Wegegeldeintrag = New Wegegeldeintrag("bis 2km bei Nacht", 7.16D)
            Case 6 : m_Wegegeldeintrag = New Wegegeldeintrag("bis 5km bei Nacht", 10.23D)
            Case 7 : m_Wegegeldeintrag = New Wegegeldeintrag("bis 10km bei Nacht", 15.34D)
            Case 8 : m_Wegegeldeintrag = New Wegegeldeintrag("bis 25km bei Nacht", 25.56D)
        End Select
    End Sub

    Public Class Wegegeldeintrag
        Private m_Text As String = ""
        Private m_Summe As Decimal = 0D
        ReadOnly Property Text() As String
            Get
                Return m_Text
            End Get
        End Property
        ReadOnly Property Summe() As Decimal
            Get
                Return m_Summe
            End Get
        End Property
        Public Sub New(ByVal Text As String, ByVal Summe As Decimal)
            m_Text = Text
            m_Summe = Summe
        End Sub
    End Class

#End Region


    Private Sub ComboBoxFaktor_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBoxFaktor.TextChanged
        If m_Initialisierung Then Exit Sub
        MakeOKCheck()
    End Sub

    Private Sub ComboBoxWegegeld_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxWegegeld.SelectedIndexChanged
        Wegegeldeintrag_Ermitteln()
    End Sub
End Class
