Imports System.Windows.Forms
Imports System.Drawing
Public Class DiagnosenDataGridICDAuswahlColumn
    Inherits DataGridColumnStyle
    Private Cbo As ComboBox
    Private isEditing As Boolean

    Private m_Liste As DiagnosenDataGridListe
    Private WithEvents m_Diagnosenliste As DiagnosenListe

    Private m_DropDownWidth As Integer = 250
    WriteOnly Property DropDownWidth() As Integer
        Set(ByVal Value As Integer)
            m_DropDownWidth = Value
        End Set
    End Property
    Public Sub New(ByVal xListe As DiagnosenDataGridListe)
        m_Liste = xListe
        m_Diagnosenliste = m_Liste.Diagnosen
        Cbo = New ComboBox
        Cbo.DropDownStyle = ComboBoxStyle.DropDownList
        Cbo.Visible = False
        Cbo.Items.AddRange(m_Diagnosenliste.ToArray)
    End Sub
    Private Sub m_Diagnosenliste_Liste_Geaendert() Handles m_Diagnosenliste.Liste_Geaendert
        Cbo.Items.Clear()
        Cbo.Items.AddRange(m_Diagnosenliste.ToArray)
    End Sub
    Protected Overrides Sub Abort(ByVal rowNum As Integer)
        isEditing = False
        RemoveHandler Cbo.SelectedValueChanged, AddressOf CboValueChanged
        Invalidate()
    End Sub

    Protected Overrides Function Commit(ByVal dataSource As System.Windows.Forms.CurrencyManager, ByVal rowNum As Integer) As Boolean
        Cbo.Bounds = Rectangle.Empty

        AddHandler Cbo.SelectedValueChanged, AddressOf CboValueChanged

        If Not isEditing Then
            Return True
        End If
        isEditing = False

        Try
            Dim value As Diagnose = Cbo.SelectedItem
            'MsgBox(value.Ziffer)
            SetColumnValueAtRow(dataSource, rowNum, value)
        Catch
        End Try

        Invalidate()
        Return True
    End Function

    Protected Overloads Overrides Sub Edit(ByVal source As System.Windows.Forms.CurrencyManager, ByVal rowNum As Integer, ByVal bounds As System.Drawing.Rectangle, ByVal [readOnly] As Boolean, ByVal instantText As String, ByVal cellIsVisible As Boolean)
        If isEditing Then Exit Sub
        Dim value As Diagnose = CType(GetColumnValueAtRow([source], rowNum), Diagnose)

        If cellIsVisible Then
            Cbo.Bounds = New Rectangle(bounds.X, bounds.Y, bounds.Width, bounds.Height)
            Cbo.DropDownWidth = m_DropDownWidth
            Cbo.SelectedItem = value
            Cbo.Visible = True
            AddHandler Cbo.SelectedValueChanged, AddressOf CboValueChanged
        Else
            Cbo.SelectedItem = value
            Cbo.Visible = False
        End If

        If Cbo.Visible Then
            DataGridTableStyle.DataGrid.Invalidate(bounds)
        End If
    End Sub

    Protected Overrides Function GetMinimumHeight() As Integer
        Return Cbo.PreferredHeight
    End Function

    Protected Overrides Function GetPreferredHeight(ByVal g As System.Drawing.Graphics, ByVal value As Object) As Integer
        Return Cbo.PreferredHeight
    End Function

    Protected Overrides Function GetPreferredSize(ByVal g As System.Drawing.Graphics, ByVal value As Object) As System.Drawing.Size
        Return New Size(50, Cbo.PreferredHeight)
    End Function

    Protected Overloads Overrides Sub Paint(ByVal g As System.Drawing.Graphics, ByVal bounds As System.Drawing.Rectangle, ByVal source As System.Windows.Forms.CurrencyManager, ByVal rowNum As Integer)
        Paint(g, bounds, [source], rowNum, False)
    End Sub

    Protected Overloads Overrides Sub Paint(ByVal g As System.Drawing.Graphics, ByVal bounds As System.Drawing.Rectangle, ByVal source As System.Windows.Forms.CurrencyManager, ByVal rowNum As Integer, ByVal alignToRight As Boolean)
        Dim Eintr As Diagnose = CType(GetColumnValueAtRow([source], rowNum), Diagnose)
        Dim rect As Rectangle = bounds
        g.FillRectangle(SystemBrushes.Window, rect)

        rect.Offset(0, 2)
        rect.Height -= 2
        g.DrawString(Eintr.ICD, Me.DataGridTableStyle.DataGrid.Font, SystemBrushes.WindowText, RectangleF.FromLTRB(rect.X, rect.Y, rect.Right, rect.Bottom))

    End Sub
    Protected Overrides Sub SetDataGridInColumn(ByVal value As System.Windows.Forms.DataGrid)
        MyBase.SetDataGridInColumn(value)
        If Not (Cbo.Parent Is Nothing) Then
            Cbo.Parent.Controls.Remove(Cbo)
        End If
        If Not (value Is Nothing) Then
            value.Controls.Add(Cbo)
        End If
    End Sub
    Private ValueChanging As Boolean = False
    Private Sub CboValueChanged(ByVal sender As Object, ByVal e As EventArgs)
        If ValueChanging Then Exit Sub
        ValueChanging = True
        Me.isEditing = True
        MyBase.ColumnStartedEditing(Cbo)
        ValueChanging = False
    End Sub


End Class
