Imports System.ComponentModel
Public Class DiagnosenDataGridItem
    Implements IEditableObject
    Public Event PropertyChanged(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)
    Private m_Parent As DiagnosenDataGridListe

    Private m_Datum As DateTime = DateTime.Now
    Private WithEvents m_Diagnose As Diagnose
    Private m_Text As String = ""

    Public Sub New(ByVal parent As DiagnosenDataGridListe, ByVal xDatum As DateTime, ByVal xDiagnose As Diagnose)
        m_Parent = parent
        m_Datum = xDatum
        m_Diagnose = xDiagnose
        m_Text = xDiagnose.Text
        m_IsNew = False
    End Sub
    ' Erzeugt eine neue Instanz. Dieses Objekt wird als neu gekennzeichnet.
    Public Sub New(ByVal parent As DiagnosenDataGridListe)
        m_Parent = parent
        m_Datum = m_Parent.AktuellesDatum
        m_Diagnose = m_Parent.Diagnosen.NullDiagnose
        m_Text = m_Diagnose.Text
        m_IsNew = True
    End Sub
    Public Property Datum() As DateTime
        Get
            Return m_Datum
        End Get
        Set(ByVal Value As DateTime)
            m_Datum = Value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Datum"))
        End Set
    End Property
    Public Property Diagnose() As Diagnose
        Get
            Return m_Diagnose
        End Get
        Set(ByVal Value As Diagnose)
            m_Diagnose = Value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Diagnose"))
            m_Text = m_Diagnose.Text
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Text"))
        End Set
    End Property
    Public Property Text() As String
        Get
            Return m_Text
        End Get
        Set(ByVal Value As String)
            m_Text = Value
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Text"))
        End Set
    End Property

#Region " IEditableObject "
    Private m_Editing As Boolean
    Private m_IsNew As Boolean = True

    Private m_OldDatum As DateTime
    Private m_OldDiagnose As Diagnose
    Private m_OldText As String

    Public Sub BeginEdit() Implements System.ComponentModel.IEditableObject.BeginEdit
        If Not m_Editing Then
            m_OldDatum = m_Datum
            m_OldDiagnose = m_Diagnose
            m_OldText = m_Text
            m_Editing = True
        End If
    End Sub

    Public Sub CancelEdit() Implements System.ComponentModel.IEditableObject.CancelEdit
        If m_Editing Then
            If m_IsNew Then m_Parent.RemoveChild(Me)
            m_Datum = m_OldDatum
            m_Diagnose = m_OldDiagnose
            m_Text = m_OldText
            m_Editing = False
        End If
    End Sub

    Public Sub EndEdit() Implements System.ComponentModel.IEditableObject.EndEdit
        m_Editing = False
        m_IsNew = False
    End Sub
#End Region

    Private Sub m_Diagnose_ICD_Geaendert() Handles m_Diagnose.ICD_Geaendert
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Diagnose"))
    End Sub

    Private Sub m_Diagnose_Text_Geaendert() Handles m_Diagnose.Text_Geaendert
        m_Text = m_Diagnose.Text
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("Text"))
    End Sub
End Class
