Imports System.Environment
Imports System.Xml
Public Class DiagnosenListe
    Inherits List(Of Diagnose)

    Private m_NullDiagnose As Diagnose
    Public Event Liste_Geaendert()
    Private m_Pfad As String = ""

    Public Sub New(ByVal VorlagenPfad As String)
        m_Pfad = VorlagenPfad & "\Diagnosen.xml"
        LoadData()
    End Sub
  
    Public ReadOnly Property NullDiagnose() As Diagnose
        Get
            Return m_NullDiagnose
        End Get
    End Property
    Public Sub Aenderung_Mitteilen()
        RaiseEvent Liste_Geaendert()
    End Sub
    Private Sub LoadData()

        Dim FileName As String = m_Pfad
        If IO.File.Exists(FileName) Then
            Dim reader As New XmlTextReader(FileName)
            Try
                With reader
                    While .Read
                        If .NodeType = XmlNodeType.Element Then
                            Select Case .Name
                                Case "item"
                                    Dim ICD As String = .GetAttribute("ICD")
                                    Dim Text As String = .GetAttribute("Text")
                                    Dim D As New Diagnose(ICD, Text)
                                    Me.Add(D)
                            End Select
                        End If
                    End While
                End With
            Finally
                reader.Close()
            End Try
        Else
            Dim D1 As New Diagnose("M54.4", "Lumboischialgie")
            Me.Add(D1)
        End If
        Me.Sort(New DiagnosenComparer)
        m_NullDiagnose = New Diagnose("-", "")
        Me.Insert(0, m_NullDiagnose)

    End Sub
    Public Sub Speichern()
        Me.Remove(m_NullDiagnose)

        Me.Sort(New DiagnosenComparer)
        Dim FileName As String = m_Pfad

        Dim Writer As New XmlTextWriter(FileName, System.Text.Encoding.UTF8)
        Writer.WriteStartDocument()
        Writer.WriteStartElement("data")
        For Each D As Diagnose In Me
            If Not D Is m_NullDiagnose Then
                Writer.WriteStartElement("item")
                Writer.WriteAttributeString("ICD", D.ICD)
                Writer.WriteAttributeString("Text", D.Text)
                Writer.WriteEndElement()
            End If
        Next
        Writer.WriteEndElement()
        Writer.WriteEndDocument()
        Writer.Close()
        Me.Insert(0, m_NullDiagnose)
    End Sub
End Class
