Imports System.Windows.Forms
Imports System.Drawing
Public Class PKVLeistungDataGridTableStyle
    Inherits DataGridTableStyle
    Private m_ColDatum As DataGridDatumColumn
    Private m_ColEintrag As PKVLeistungDataGridZifferAuswahlColumn
    Private m_ColText As PKVLeistungDataGridTextColumn
    Private m_ColPunktzahl As DataGridTextBoxColumn
    Private m_ColFaktor As PKVLeistungDataGridFaktorColumn
    Private m_ColBetrag As DataGridTextBoxColumn
    ReadOnly Property ColDatum() As DataGridDatumColumn
        Get
            Return m_ColDatum
        End Get
    End Property
    ReadOnly Property ColEintrag() As PKVLeistungDataGridZifferAuswahlColumn
        Get
            Return m_ColEintrag
        End Get
    End Property
    ReadOnly Property ColText() As PKVLeistungDataGridTextColumn
        Get
            Return m_ColText
        End Get
    End Property
    ReadOnly Property ColPunktzahl() As DataGridTextBoxColumn
        Get
            Return m_ColPunktzahl
        End Get
    End Property
    ReadOnly Property ColFaktor() As PKVLeistungDataGridFaktorColumn
        Get
            Return m_ColFaktor
        End Get
    End Property
    ReadOnly Property ColBetrag() As DataGridTextBoxColumn
        Get
            Return m_ColBetrag
        End Get
    End Property


    Public Sub New(ByVal xListe As PKVLeistungDataGridListe)
        Me.MappingName = "PKVLeistungDataGridListe"

        m_ColDatum = New DataGridDatumColumn
        ColDatum.MappingName = "Datum"
        ColDatum.HeaderText = "Datum"
        ColDatum.Width = 75
        ColDatum.Format = "d"
        Me.GridColumnStyles.Add(ColDatum)

        m_ColEintrag = New PKVLeistungDataGridZifferAuswahlColumn(xListe)
        ColEintrag.MappingName = "Leistung"
        ColEintrag.HeaderText = "Ziffer"
        ColEintrag.Width = 50
        Me.GridColumnStyles.Add(ColEintrag)

        m_ColText = New PKVLeistungDataGridTextColumn(xListe)
        ColText.MappingName = "Text"
        ColText.HeaderText = "Text"
        ColText.Width = 200
        Me.GridColumnStyles.Add(ColText)

        m_ColPunktzahl = New DataGridTextBoxColumn
        ColPunktzahl.MappingName = "Punktzahl"
        ColPunktzahl.HeaderText = "Punktzahl"
        ColPunktzahl.ReadOnly = True
        ColPunktzahl.Alignment = HorizontalAlignment.Left
        ColPunktzahl.Width = 80
        Me.GridColumnStyles.Add(ColPunktzahl)

        m_ColFaktor = New PKVLeistungDataGridFaktorColumn(xListe)
        ColFaktor.MappingName = "Faktor"
        ColFaktor.HeaderText = "Faktor"
        ColFaktor.Alignment = HorizontalAlignment.Center
        ColFaktor.Width = 40
        Me.GridColumnStyles.Add(ColFaktor)

        m_ColBetrag = New DataGridTextBoxColumn
        ColBetrag.MappingName = "Betrag"
        ColBetrag.HeaderText = "Betrag"
        ColBetrag.Format = "c"
        ColBetrag.Alignment = HorizontalAlignment.Right
        ColBetrag.Width = 75
        Me.GridColumnStyles.Add(ColBetrag)

    End Sub

End Class
