Imports System.Xml
Imports System.ComponentModel
Imports System.Environment
Public Class PKVLeistungsListe
    Inherits List(Of PKVLeistung)
    Private m_Nulleintrag As PKVLeistung
    Public Event Liste_Geaendert()
    Private m_Pfad As String = ""
    ReadOnly Property Nulleintrag() As PKVLeistung
        Get
            Return m_Nulleintrag
        End Get
    End Property
    Public Sub Aenderung_Mitteilen()
        RaiseEvent Liste_Geaendert()
    End Sub
    Public Sub New(ByVal Vorlagenpfad As String)
        LoadData(Vorlagenpfad)
    End Sub
   
    Public Sub LoadData(ByVal Vorlagenpfad As String)
        m_Pfad = Vorlagenpfad & "\PKVLeistungen.xml"


        If IO.File.Exists(m_Pfad) Then
            Dim reader As New XmlTextReader(m_Pfad)
            Try
                With reader
                    While .Read
                        If .NodeType = XmlNodeType.Element Then
                            Select Case .Name
                                Case "item"
                                    Dim Ziffer As String = .GetAttribute("Ziffer")
                                    Dim Text As String = .GetAttribute("Text")
                                    Dim Punktzahl As Integer = CInt(.GetAttribute("Punktzahl"))
                                    Dim MaxFaktor As Decimal = CDec(.GetAttribute("MaxFaktor"))
                                    Dim IstFestwert As Boolean = CBool(.GetAttribute("IstFestWert"))
                                    Dim Festwert As Decimal = CDec(.GetAttribute("Festwert"))
                                    Dim Eintrag As New PKVLeistung(Ziffer, Text, Punktzahl, MaxFaktor, IstFestwert, Festwert)
                                    Me.Add(Eintrag)
                            End Select
                        End If
                    End While
                End With
            Finally
                reader.Close()
            End Try
        Else
            Dim A1 As New PKVLeistung("-", "Wegegeld bis zwei Kilometer", 0, CDec(0), True, CDec(3.58))
            Me.Add(A1)
            Dim A2 As New PKVLeistung("-", "Wegegeld bis zwei Kilometer bei Nacht", 0, CDec(0), True, CDec(7.16))
            Me.Add(A2)
            Dim A3 As New PKVLeistung("-", "Wegegeld bis fnf Kilometer", 0, CDec(0), True, CDec(6.65))
            Me.Add(A3)
            Dim A4 As New PKVLeistung("-", "Wegegeld bis fnf Kilometer bei Nacht", 0, CDec(0), True, CDec(10.23))
            Me.Add(A4)
            Dim A5 As New PKVLeistung("-", "Wegegeld bis zehn Kilometer", 0, CDec(0), True, CDec(10.23))
            Me.Add(A5)
            Dim A6 As New PKVLeistung("-", "Wegegeld bis zehn Kilometer bei Nacht", 0, CDec(0), True, CDec(15.34))
            Me.Add(A6)
            Dim A7 As New PKVLeistung("-", "Wegegeld bis 25 Kilometer", 0, CDec(0), True, CDec(15.34))
            Me.Add(A7)
            Dim A8 As New PKVLeistung("-", "Wegegeld bis 25 Kilometer bei Nacht", 0, CDec(0), True, CDec(25.56))
            Me.Add(A8)

            Dim x As New PKVLeistung("1", "Beratung, auch telefonisch", 80, CDec(2.3), False, CDec(0))
            Me.Add(x)
            Dim y As New PKVLeistung("3", "Eingehende, das gewhnliche Ma berschreitende Beratung, auch telefonisch", 150, CDec(2.3), False, CDec(0))
            Me.Add(y)
        End If

        Me.Sort(New PKVLeistungsListenComparer)

        m_Nulleintrag = New PKVLeistung("-", "", 0, CDec(0), False, CDec(0))
        Me.Add(m_Nulleintrag)



    End Sub
    Public Sub Speichern()
        Me.Remove(m_Nulleintrag)
        Me.Sort(New PKVLeistungsListenComparer)

        Dim Writer As New XmlTextWriter(m_Pfad, System.Text.Encoding.UTF8)
        Writer.WriteStartDocument()
        Writer.WriteStartElement("data")
        For Each D As PKVLeistung In Me
            If Not D Is m_Nulleintrag Then
                Writer.WriteStartElement("item")
                Writer.WriteAttributeString("Festwert", D.Festwert.ToString)
                Writer.WriteAttributeString("Text", D.Text)
                Writer.WriteAttributeString("IstFestWert", D.IstFestWert.ToString)
                Writer.WriteAttributeString("MaxFaktor", D.MaxFaktor.ToString)
                Writer.WriteAttributeString("Punktzahl", D.Punktzahl.ToString)
                Writer.WriteAttributeString("Ziffer", D.Ziffer)
                Writer.WriteEndElement()
            End If
        Next
        Writer.WriteEndElement()
        Writer.WriteEndDocument()
        Writer.Close()
        Me.Insert(0, m_Nulleintrag)
    End Sub
End Class
