Imports System.Drawing
Imports System.Windows.Forms
Public Class frm_Leistungenbearbeiten

    Private Liste_Leistungen As PKVLeistungsListe
    Private Liste_Leistungen_Kopien As List(Of PKVLeistung)
    Private Initialisierung As Boolean = False
    Private ListBoxAktualisierung As Boolean = False
    Private ListboxWechsel As Boolean = False
    Private AppName As String = ""
    Private DataGridListe As PKVLeistungDataGridListe

    Public Sub New(ByVal DataGridListe As PKVLeistungDataGridListe)
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
        Me.Text = "Leistungen bearbeiten"
        Me.DataGridListe = DataGridListe
        Liste_Leistungen = DataGridListe.ZiffernListe
        Weitere_Initialisierung()
    End Sub
    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    Private Sub Weitere_Initialisierung()
        Liste_Leistungen_Kopien = New List(Of PKVLeistung)
        For Each D As PKVLeistung In Liste_Leistungen
            Dim C As New LeistungsKopie(D, Liste_Leistungen.Nulleintrag, DataGridListe)
            ListBoxLeistungen.Items.Add(C)
        Next
        ListBoxLeistungen.SelectedIndex = 0
    End Sub
    Private Class LeistungsKopie
        Public Leistung_Original As PKVLeistung
        Public Leistung_Kopie As PKVLeistung
        Public EditAllowed As Boolean = True
        Public Changed As Boolean = False
        Public Sub New()
            Leistung_Original = Nothing
            Leistung_Kopie = New PKVLeistung("-", "Neue Leistung", 0, CDec(0), False, CDec(0))
        End Sub
        Public Sub New(ByVal L As PKVLeistung, ByVal NullPKVLeistung As PKVLeistung, ByVal DGListe As PKVLeistungDataGridListe)
            Leistung_Original = L
            Leistung_Kopie = New PKVLeistung(L.Ziffer, L.Text, L.Punktzahl, L.MaxFaktor, L.IstFestWert, L.Festwert)
            If L Is NullPKVLeistung Then
                EditAllowed = False
            Else
                For Each Itm As PKVLeistungDataGridItem In DGListe
                    If Itm.Leistung Is L Then
                        EditAllowed = False
                        Exit For
                    End If
                Next
            End If
        End Sub
        Property Ziffer() As String
            Get
                Return Leistung_Kopie.Ziffer
            End Get
            Set(ByVal Value As String)
                Leistung_Kopie.Ziffer = Value
                Changed = True
            End Set
        End Property
        Property Text() As String
            Get
                Return Leistung_Kopie.Text
            End Get
            Set(ByVal Value As String)
                Leistung_Kopie.Text = Value
                Changed = True
            End Set
        End Property
        Property Punktzahl() As Integer
            Get
                Return Leistung_Kopie.Punktzahl
            End Get
            Set(ByVal Value As Integer)
                Leistung_Kopie.Punktzahl = Value
                Changed = True
            End Set
        End Property
        Property MaxFaktor() As Decimal
            Get
                Return Leistung_Kopie.MaxFaktor
            End Get
            Set(ByVal Value As Decimal)
                Leistung_Kopie.MaxFaktor = Value
                Changed = True
            End Set
        End Property
        Property Festwert() As Decimal
            Get
                Return Leistung_Kopie.Festwert
            End Get
            Set(ByVal Value As Decimal)
                Leistung_Kopie.Festwert = Value
                Changed = True
            End Set
        End Property
        Property IstFestWert() As Boolean
            Get
                Return Leistung_Kopie.IstFestWert
            End Get
            Set(ByVal Value As Boolean)
                Leistung_Kopie.IstFestWert = Value
                Changed = True
            End Set
        End Property
        Public Overrides Function ToString() As String
            Return Ziffer & " " & Text
        End Function
    End Class

    Private Sub ListBoxLeistungen_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBoxLeistungen.SelectedIndexChanged
        If ListBoxAktualisierung Then Exit Sub
        Initialisierung = True
        Dim D As LeistungsKopie = ListBoxLeistungen.SelectedItem
        Me.TextBoxZiffer.Text = D.Ziffer
        Me.TextBoxText.Text = D.Text
        Me.TextBoxPunkte.Text = D.Punktzahl
        Me.TextBoxFestbetrag.Text = D.Festwert
        Me.TextBoxMaxFaktor.Text = D.MaxFaktor
        Me.CheckBoxFestwert.Checked = D.IstFestWert

        Me.TextBoxZiffer.Enabled = D.EditAllowed
        Me.TextBoxText.Enabled = D.EditAllowed

        If Not D.EditAllowed Then
            Me.TextBoxPunkte.Enabled = False
            Me.TextBoxFestbetrag.Enabled = False
            Me.TextBoxMaxFaktor.Enabled = False
            Me.CheckBoxFestwert.Enabled = False
        Else
            Me.TextBoxFestbetrag.Enabled = D.IstFestWert
            Me.TextBoxPunkte.Enabled = Not D.IstFestWert
            Me.TextBoxMaxFaktor.Enabled = Not D.IstFestWert

            Me.CheckBoxFestwert.Enabled = True
        End If

        Me.BtnLschen.Enabled = D.EditAllowed

        Initialisierung = False
    End Sub

    Private Sub TextBoxZiffer_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxZiffer.TextChanged
        If Initialisierung Then Exit Sub
        Dim D As LeistungsKopie = ListBoxLeistungen.SelectedItem
        D.Ziffer = Me.TextBoxZiffer.Text
        ListBoxAuffrischen()
    End Sub

    Private Sub TextBoxText_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxText.TextChanged
        If Initialisierung Then Exit Sub
        Dim D As LeistungsKopie = ListBoxLeistungen.SelectedItem
        D.Text = Me.TextBoxText.Text
        ListBoxAuffrischen()
    End Sub
    Private Sub TextBoxPunkte_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxPunkte.TextChanged
        If Initialisierung Then Exit Sub
        Dim D As LeistungsKopie = ListBoxLeistungen.SelectedItem
        Try
            D.Punktzahl = CInt(Me.TextBoxPunkte.Text)
        Catch ex As Exception

        End Try

    End Sub

    Private Sub TextBoxFestbetrag_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxFestbetrag.TextChanged
        If Initialisierung Then Exit Sub
        Dim D As LeistungsKopie = ListBoxLeistungen.SelectedItem
        Try
            D.Festwert = CDec(Me.TextBoxFestbetrag.Text)
        Catch ex As Exception

        End Try

    End Sub

    Private Sub TextBoxMaxFaktor_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxMaxFaktor.TextChanged
        If Initialisierung Then Exit Sub
        Dim D As LeistungsKopie = ListBoxLeistungen.SelectedItem
        Try
            D.MaxFaktor = CDec(Me.TextBoxMaxFaktor.Text)
        Catch ex As Exception

        End Try

    End Sub
    Private Sub CheckBoxFestwert_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxFestwert.CheckedChanged
        If Initialisierung Then Exit Sub
        Dim D As LeistungsKopie = ListBoxLeistungen.SelectedItem
        D.IstFestWert = Me.CheckBoxFestwert.Checked

        If D.IstFestWert Then
            Me.TextBoxPunkte.Text = "0"
            Me.TextBoxMaxFaktor.Text = "0"
            If Not IsNothing(D.Leistung_Original) Then
                Me.TextBoxFestbetrag.Text = D.Leistung_Original.Festwert.ToString
            Else
                Me.TextBoxFestbetrag.Text = "0"
            End If
        Else
            Me.TextBoxFestbetrag.Text = "0"
            If Not IsNothing(D.Leistung_Original) Then
                Me.TextBoxPunkte.Text = D.Leistung_Original.Punktzahl.ToString
                Me.TextBoxMaxFaktor.Text = D.Leistung_Original.MaxFaktor.ToString
            Else
                Me.TextBoxPunkte.Text = "0"
                Me.TextBoxMaxFaktor.Text = "0"
            End If
        End If

        Me.TextBoxFestbetrag.Enabled = D.IstFestWert
        Me.TextBoxPunkte.Enabled = Not D.IstFestWert
        Me.TextBoxMaxFaktor.Enabled = Not D.IstFestWert
    End Sub
    Private Sub ListBoxAuffrischen()
        ListBoxAktualisierung = True
        Dim Merkindex As Integer = ListBoxLeistungen.SelectedIndex
        Dim Merkitem As LeistungsKopie = ListBoxLeistungen.SelectedItem
        ListBoxLeistungen.Items.Remove(Merkitem)
        ListBoxLeistungen.Items.Insert(Merkindex, Merkitem)
        ListBoxLeistungen.SelectedIndex = Merkindex

        ListBoxAktualisierung = False
    End Sub
    Private Sub ButtonNeu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonNeu.Click
        Dim D As New LeistungsKopie
        ListBoxLeistungen.Items.Add(D)
        ListBoxLeistungen.SelectedItem = D
    End Sub

    Private Sub BtnLschen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnLschen.Click
        If System.Windows.Forms.MessageBox.Show("Diese Leistung wirklich lschen?", AppName, Windows.Forms.MessageBoxButtons.YesNo, Windows.Forms.MessageBoxIcon.Question) = Windows.Forms.DialogResult.No Then
            Exit Sub
        End If

        ListBoxAktualisierung = True
        Dim Merkindex As Integer = ListBoxLeistungen.SelectedIndex
        Dim Merkitem As LeistungsKopie = ListBoxLeistungen.SelectedItem
        ListBoxLeistungen.Items.Remove(Merkitem)
        ListBoxAktualisierung = False

        If ListBoxLeistungen.Items.Count > Merkindex + 1 Then
            ListBoxLeistungen.SelectedIndex = Merkindex
        Else
            ListBoxLeistungen.SelectedIndex = Merkindex - 1
        End If
    End Sub


    Private Sub ButtonOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOK.Click
        Dim Geaendert As Boolean = False

        For I As Integer = Liste_Leistungen.Count - 1 To 0 Step -1
            Dim D As PKVLeistung = Liste_Leistungen(I)
            Dim SuchKopie As LeistungsKopie = Nothing
            For Each DC As LeistungsKopie In Me.ListBoxLeistungen.Items
                If DC.Leistung_Original Is D Then
                    SuchKopie = DC
                    Exit For
                End If
            Next
            If IsNothing(SuchKopie) Then
                Liste_Leistungen.RemoveAt(I)
                Geaendert = True
            Else
                If SuchKopie.Changed Then
                    D.Ziffer = SuchKopie.Leistung_Kopie.Ziffer
                    D.Text = SuchKopie.Leistung_Kopie.Text
                    D.IstFestWert = SuchKopie.Leistung_Kopie.IstFestWert
                    D.MaxFaktor = SuchKopie.Leistung_Kopie.MaxFaktor
                    D.Festwert = SuchKopie.Leistung_Kopie.Festwert
                    D.Punktzahl = SuchKopie.Leistung_Kopie.Punktzahl
                    Geaendert = True
                End If
            End If
        Next

        For Each S1Kopie As LeistungsKopie In Me.ListBoxLeistungen.Items
            If IsNothing(S1Kopie.Leistung_Original) Then
                Liste_Leistungen.Add(S1Kopie.Leistung_Kopie)
                Geaendert = True
            End If
        Next
        If Geaendert Then
            Liste_Leistungen.Speichern()
            Liste_Leistungen.Aenderung_Mitteilen()
        End If
    End Sub
    Private Sub ButtonEinfuegen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonEinfuegen.Click
        Dim Texte(1) As String
        Try
            Dim iData As IDataObject = Clipboard.GetDataObject()
            If iData.GetDataPresent(DataFormats.Text) Then
                Dim GText As String = iData.GetData("System.String", True).ToString()
                Dim Startzahl As Integer = GText.IndexOf(" ")
                Dim Teil1 = GText.Substring(0, Startzahl).Trim
                Dim Teil2 As String = GText.Substring(Startzahl).Trim
                Dim D As New PKVLeistung(Teil1, Teil2)
                Dim Cp As New LeistungsKopie
                Cp.Leistung_Kopie = D

                Me.ListBoxLeistungen.Items.Add(Cp)
                Me.ListBoxLeistungen.SelectedItem = Cp
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, AppName, MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub




End Class