Imports Briefdatenbank.Plugin.Common
Public Class frm_Arbeit1
    Implements Briefdatenbank.Plugin.Common.IPlugInForm

    Private WithEvents m_Summenrechner As SummenBerechnerFuerOstAbschlag

#Region "Constructor "
    Public Sub New()
        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
    End Sub
    Public Sub New(ByVal Daten As Briefdatenbank.Plugin.Common.PlugInUebergabeDaten)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Summenrechner = New SummenBerechnerFuerOstAbschlag(False)
        m_Summenrechner.OstAbschlag_verwenden = CheckBoxMinusZehnProzent.Checked
        DatenUebernahme(Daten)
    End Sub
    Public Overrides Sub DatenUebernahme(ByVal Daten As Briefdatenbank.Plugin.Common.PlugInUebergabeDaten)
        MyBase.DatenUebernahme(Daten)

        Me.PkvLeistungsDataGrid1.Initialisieren(Daten.VorlagenPfad)
        Me.DiagnosenDataGrid1.Initialisieren(Daten.VorlagenPfad)

        ReadDataFromDataSetString(Daten)

        Werte_OhneEventsLesen()
        MakeOKCheck()
        m_Initialisierung = False
        Summe_Berechnen()
    End Sub
    Public Overrides Sub Werte_OhneEventsLesen()
        MyBase.Werte_OhneEventsLesen()

    End Sub
    Public ReadOnly Property Result() As Common.PlugInResult Implements Common.IPlugInForm.Result
        Get
            Return m_Result
        End Get
    End Property
#End Region

#Region " OKCheck "
    Overrides Function CheckOK() As Boolean
        If MyBase.CheckOK Then
            If ComboBoxFaktor.ForeColor <> Color.Red Then
                If Me.DiagnosenDataGrid1.Zeilenzahl > 0 Then
                    If Me.PkvLeistungsDataGrid1.Summe > 0 Then
                        Return True
                    End If
                End If
            End If
        End If
        Return False
    End Function
    Overrides Sub MakeOKCheck()
        Me.ButtonOK.Enabled = CheckOK()
    End Sub
#End Region


    Public Sub ReadDataFromDataSetString(ByVal Daten As Briefdatenbank.Plugin.Common.PlugInUebergabeDaten) Implements Common.IPlugInForm.ReadDataFromDataSetString
        If Daten.XMLWert <> "" Then
            Dim DS As New BasisDataSet
            Dim Reader As New System.IO.StringReader(Daten.XMLWert)
            DS.ReadXml(Reader)
            Dim Rw As BasisDataSet.EinfachRow = DS.Einfach.Rows(0)

            Me.RechungNummerTextBox.Text = Rw.RechnungsNummer
            Me.BriefdatumDateTextBox.Text = Rw.Briefdatum.ToShortDateString
            Me.BetreffTextBox.Text = Rw.Betreff


            Me.ComboBoxFaktor.Text = Rw.MaxFaktorText
            Me.CheckBoxMinusZehnProzent.Checked = Rw.MinusZehnProzent


            Me.ComboBoxFrist.Text = Rw.Frist
            Me.KontenAuswahl1.Konto_Von_Aussen_Einstellen(Rw.Konto)

            Dim Liste As DiagnosenDataGridListe = Me.DiagnosenDataGrid1.Liste
            Dim Itm As DiagnosenDataGridItem = Nothing

            Dim LDiag As Diagnose = Nothing
            Dim FDiag As Diagnose = Nothing

            For Each DR As BasisDataSet.DiagnosenRow In DS.Diagnosen
                Itm = Me.DiagnosenDataGrid1.Liste.AddNew()
                Itm.Datum = DR.Datum

                LDiag = Nothing
                FDiag = Nothing

                For Each Diag As Diagnose In Liste.Diagnosen
                    If Diag.ICD = DR.ICDNr Then
                        LDiag = Diag
                        If Diag.Text = DR.ICDText Then
                            FDiag = Diag
                            Exit For
                        End If
                    End If
                Next

                If FDiag IsNot Nothing Then
                    Itm.Diagnose = FDiag
                ElseIf LDiag IsNot Nothing Then
                    Itm.Diagnose = LDiag
                End If

                Itm.Text = DR.ICDText
            Next


            Dim ListeL As PKVLeistungDataGridListe = Me.PkvLeistungsDataGrid1.Liste

            Dim ItmL As PKVLeistungDataGridItem = Nothing
            Dim LLstg As PKVLeistung = Nothing
            Dim FLstg As PKVLeistung = Nothing

            For Each DR As BasisDataSet.LeistungenRow In DS.Leistungen
                ItmL = Me.PkvLeistungsDataGrid1.Liste.AddNew
                ItmL.Datum = DR.Datum

                LLstg = Nothing
                FLstg = Nothing
                For Each Lstg As PKVLeistung In ListeL.ZiffernListe
                    If Lstg.Ziffer = DR.LeistungsNr Then
                        LLstg = Lstg
                        If Lstg.Text = DR.LeistungsText Then
                            FLstg = Lstg
                        End If
                    End If
                Next

                If FLstg IsNot Nothing Then
                    ItmL.Leistung = FLstg
                ElseIf LLstg IsNot Nothing Then
                    ItmL.Leistung = LLstg
                End If

                ItmL.Punktzahl = DR.Punktzahl
                ItmL.Text = DR.LeistungsText
                ItmL.Faktor = DR.Faktor
                ItmL.Betrag = DR.Betrag
            Next

            Dim PDT As Briefdatenbank.Plugin.Common.PostenDataset.PostenlisteDataTable = Me.PostenDataGridView1.PostenlisteDataTable
            Dim Rwx As Briefdatenbank.Plugin.Common.PostenDataset.PostenlisteRow = Nothing
            For Each Rw1 As BasisDataSet.ExtraLeistungenRow In DS.ExtraLeistungen.Rows
                Rwx = PDT.NewRow()
                Rwx.Betrag = Rw1.Betrag
                Rwx.Posten = Rw1.Posten
                PDT.Rows.Add(Rwx)
            Next


        End If
    End Sub

    Public Sub WriteDataToDataSetString() Implements Common.IPlugInForm.WriteDataToDataSetString
        Dim DS As New BasisDataSet
        Dim Rw As BasisDataSet.EinfachRow = DS.Einfach.NewRow

        Rw.RechnungsNummer = Me.RechungNummerTextBox.Text
        Rw.Briefdatum = Me.BriefdatumDateTextBox.Text
        Rw.Betreff = Me.BetreffTextBox.Text

        Rw.MaxFaktorText = Me.ComboBoxFaktor.Text
        Rw.MinusZehnProzent = Me.CheckBoxMinusZehnProzent.Checked

        Rw.Frist = Me.ComboBoxFrist.Text
        Rw.Konto = Me.KontenAuswahl1.AktuellesKonto.Name

        DS.Einfach.Rows.Add(Rw)


        For Each Itm As PKVLeistungDataGridItem In Me.PkvLeistungsDataGrid1.Liste
            Dim RwLstg As BasisDataSet.LeistungenRow = DS.Leistungen.NewRow
            RwLstg.Datum = Itm.Datum
            RwLstg.Betrag = Itm.Betrag
            RwLstg.Faktor = Itm.Faktor
            RwLstg.LeistungsNr = Itm.Leistung.Ziffer
            RwLstg.LeistungsText = Itm.Text
            RwLstg.Punktzahl = Itm.Punktzahl

            DS.Leistungen.Rows.Add(RwLstg)
        Next

        For Each Itm As DiagnosenDataGridItem In Me.DiagnosenDataGrid1.Liste
            Dim RwDiag As BasisDataSet.DiagnosenRow = DS.Diagnosen.NewRow
            RwDiag.Datum = Itm.Datum
            RwDiag.ICDNr = Itm.Diagnose.ICD
            RwDiag.ICDText = Itm.Text
            DS.Diagnosen.Rows.Add(RwDiag)
        Next


        Dim Rwx As BasisDataSet.ExtraLeistungenRow = Nothing
        Dim PDT As Briefdatenbank.Plugin.Common.PostenDataset.PostenlisteDataTable = Me.PostenDataGridView1.PostenlisteDataTable
        For Each rw1 As Briefdatenbank.Plugin.Common.PostenDataset.PostenlisteRow In PDT
            Rwx = DS.ExtraLeistungen.NewRow
            Rwx.Betrag = rw1.Betrag
            Rwx.Posten = rw1.Posten
            DS.ExtraLeistungen.Rows.Add(Rwx)
        Next


        Dim sB As New System.Text.StringBuilder
        Dim writer As New System.IO.StringWriter(sB)
        DS.WriteXml(writer)

        m_Result.PersistText = sB.ToString
    End Sub

    Private Sub CheckBoxMinusZehnProzent_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxMinusZehnProzent.CheckedChanged
        If m_Initialisierung Then Exit Sub
        m_Summenrechner.OstAbschlag_verwenden = CheckBoxMinusZehnProzent.Checked
        'Summe_Berechnen()
    End Sub

    Private Sub ComboBoxFaktor_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxFaktor.TextChanged
        If m_Initialisierung Then Exit Sub
        Try
            Dim Maxfakt As Decimal = CDec(ComboBoxFaktor.Text)
            Me.PkvLeistungsDataGrid1.MaxFactor = Maxfakt
            ComboBoxFaktor.ForeColor = SystemColors.WindowText

        Catch ex As Exception
            ComboBoxFaktor.ForeColor = Color.Red
        End Try

        MakeOKCheck()
    End Sub



    Private Sub ButtonOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOK.Click
        Me.KontenAuswahl1.Speichern()
        WriteResultText()
        WriteDataToDataSetString()
    End Sub
    Private Sub WriteResultText()
        Dim P As TextParagraph
        'Dim Tab As Table

        m_Result.Datum = CDate(Me.BriefdatumDateTextBox.Text)
        m_Result.BetreffText = Me.BetreffTextBox.Text.Trim
        m_Result.RechnungsNummer = Me.RechungNummerTextBox.Text.Trim


        Dim Checker As New MinMaxDatumChecker

        For Each itm As PKVLeistungDataGridItem In Me.PkvLeistungsDataGrid1.Liste
            Checker.CheckDate(itm.Datum)
        Next
        For Each itm As DiagnosenDataGridItem In Me.DiagnosenDataGrid1.Liste
            Checker.CheckDate(itm.Datum)
        Next

        Dim MindatumTxt As String = Format(Checker.MinDatum, "d")
        Dim MaxdatumTxt As String = Format(Checker.MaxDatum, "d")






        P = New TextParagraph
        P.Alignment = ParagraphAlignments.Block
        m_Result.Liste_Texte.Add(P)

        If MindatumTxt = MaxdatumTxt Then
            P.TextEintraege.Add(New TextEintrag("fr die Behandlung am"))
            P.TextEintraege.Add(New TextEintrag(MindatumTxt, TextFormats.Bold))
        Else
            P.TextEintraege.Add(New TextEintrag("fr die Behandlung im Zeitraum vom"))
            P.TextEintraege.Add(New TextEintrag(MindatumTxt, TextFormats.Bold))
            P.TextEintraege.Add(New TextEintrag("bis zum"))
            P.TextEintraege.Add(New TextEintrag(MaxdatumTxt, TextFormats.Bold))
        End If
        P.TextEintraege.Add(New TextEintrag("stelle ich Ihnen einen Betrag in Hhe von"))
        P.TextEintraege.Add(New TextEintrag(Format(m_Summe, "c"), TextFormats.Bold))
        P.TextEintraege.Add(New TextEintrag("in Rechnung. Im folgenden erhalten Sie eine detaillierte Auflistung der zugrunde liegenden Diagnosen und Leistungen."))


        P = New TextParagraph
        m_Result.Liste_Texte.Add(P)
        P.TextEintraege.Add(New TextEintrag("Diagnosen", TextFormats.Bold))

        m_Result.Liste_Texte.Add(Me.DiagnosenDataGrid1.ToTable)

        P = New TextParagraph
        m_Result.Liste_Texte.Add(P)
        P.TextEintraege.Add(New TextEintrag("Leistungen", TextFormats.Bold))

        Dim PDT As Briefdatenbank.Plugin.Common.PostenDataset.PostenlisteDataTable = Me.PostenDataGridView1.PostenlisteDataTable
        m_Result.Liste_Texte.Add(Me.PkvLeistungsDataGrid1.ToTable(m_Summenrechner, PDT))


        m_Result.Geldbetrag = m_Summe * CDec(-1)
        m_Result.Liste_Texte.Add(KontenAuswahl1.ToRechnungsTextParagraph(m_Summe, Me.RechungNummerTextBox.Text, Spaetestdatum))
        m_Result.Liste_Texte.Add(KontenAuswahl1.ToKontoTable)


    End Sub



    Private Sub ButtonDiagnosen_Bearbeiten_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDiagnosen_Bearbeiten.Click
        Me.DiagnosenDataGrid1.Diagnosen_Bearbeiten()
    End Sub

    Private Sub ButtonLeistungen_Bearbeiten_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLeistungen_Bearbeiten.Click
        Me.PkvLeistungsDataGrid1.Leistungen_Bearbeiten()
    End Sub

    Private Sub DiagnosenDataGrid1_Zeilen_geaendert() Handles DiagnosenDataGrid1.Zeilen_geaendert
        If m_Initialisierung Then Exit Sub
        MakeOKCheck()
    End Sub

    Private Sub PkvLeistungsDataGrid1_Summe_geaendert() Handles PkvLeistungsDataGrid1.Summe_geaendert
        If m_Initialisierung Then Exit Sub
        m_Summenrechner.AusgangsBetrag = PkvLeistungsDataGrid1.Summe
    End Sub

    Private Sub PkvLeistungsDataGrid1_Zeilen_geaendert() Handles PkvLeistungsDataGrid1.Zeilen_geaendert
        If m_Initialisierung Then Exit Sub
        MakeOKCheck()
    End Sub

    Private Sub m_Summenrechner_Geaendert() Handles m_Summenrechner.Geaendert
        If m_Initialisierung Then Exit Sub
        Summe_Berechnen()
    End Sub

    Private Sub PostenDataGridView1_Summe_Geaendert() Handles PostenDataGridView1.Summe_Geaendert
        If m_Initialisierung Then Exit Sub
        Summe_Berechnen()
        MakeOKCheck()
    End Sub

    Private m_Summe As Decimal = 0D
    Private Sub Summe_Berechnen()
        m_Summe = m_Summenrechner.Ergebnis + PostenDataGridView1.Summe
        Me.RechnungsbetragTextBox.Text = Format(m_Summe, "c")
    End Sub
End Class
