Public Class BriefBearbeitungsService

    Private m_plugIns As List(Of PlugInDescriptor)

    Public Sub New()
        Dim adSetup As New AppDomainSetup
        adSetup.PrivateBinPath = "PIWork"

        ' create appdomain to load all potential plug-in assemblies into to check
        ' if they contain plug-in classes
        Dim Dom As AppDomain = AppDomain.CreateDomain("CompilePlugIns", Nothing, adSetup)

        Dim Collector As PlugInCollector
        Collector = Dom.CreateInstanceAndUnwrap("Briefdatenbank.Service", "Briefdatenbank.Service.PlugInCollector")
        m_plugIns = Collector.GetPlugInList()

        ' unload appdomain to free all assemblies from memory
        AppDomain.Unload(Dom)

    End Sub

    Public Function GetProcessorList() As Briefdatenbank.Plugin.Common.PlugInDescription()
        Dim descriptions As New List(Of Briefdatenbank.Plugin.Common.PlugInDescription)
        For Each pid As PlugInDescriptor In m_plugIns
            descriptions.Add(pid.description)
        Next
        Return descriptions.ToArray()
    End Function

    Public Event Arbeit_Ausgefuehrt(ByVal Descr As Briefdatenbank.Plugin.Common.PlugInDescription, ByVal Res As Briefdatenbank.Plugin.Common.PlugInResult)
    Public Sub Arbeiten(ByVal Descr As Briefdatenbank.Plugin.Common.PlugInDescription, ByVal UebergabeDaten As Briefdatenbank.Plugin.Common.PlugInUebergabeDaten)
        For Each PD As PlugInDescriptor In m_plugIns
            If PD.description.PluginID = Descr.PluginID Then
                Dim Res As Briefdatenbank.Plugin.Common.PlugInResult = PD.plugIn.Arbeiten(UebergabeDaten)
                RaiseEvent Arbeit_Ausgefuehrt(Descr, Res)
                Exit For
            End If
        Next
    End Sub
    Public Function ReEdit(ByVal Descr As Briefdatenbank.Plugin.Common.PlugInDescription, ByVal UebergabeDaten As Briefdatenbank.Plugin.Common.PlugInUebergabeDaten) As Briefdatenbank.Plugin.Common.PlugInResult
        For Each PD As PlugInDescriptor In m_plugIns
            If PD.description.PluginID = Descr.PluginID Then
                Return PD.plugIn.Arbeiten(UebergabeDaten)
            End If
        Next
        Return Nothing
    End Function
    Public Sub Entladen()
        For Each pid As PlugInDescriptor In m_plugIns
            pid.Entladen()
        Next
        m_plugIns.Clear()
    End Sub
   

End Class


