'TODO: FileSystemWatcher einrichten und PlugIns autom. nachladen

Imports System.Security
Imports System.Security.Policy


<Serializable()> _
Public Class PlugInDescriptor

    'Private _description As String
    Private _assemblyPath As String
    Private _typename As String

    Private _adPlugIn As AppDomain
    Private _plugIn As Briefdatenbank.Plugin.Common.IPlugIn


    Public Sub New(ByVal assemblyPath As String, ByVal typename As String)
        _assemblyPath = assemblyPath
        _typename = typename

        LoadPlugIn()
    End Sub

    Private Sub LoadPlugIn()
        If Not _adPlugIn Is Nothing Then
            AppDomain.Unload(_adPlugIn)
        End If

        Dim ads As New AppDomainSetup
        ads.ApplicationBase = IO.Path.GetDirectoryName(_assemblyPath)
        ads.ConfigurationFile = _assemblyPath & ".config"
        ads.ShadowCopyFiles = "true"

        _adPlugIn = AppDomain.CreateDomain(typename, Nothing, ads)

        ' create plug-in instance
        Dim assemblyFilename As String = IO.Path.GetFileNameWithoutExtension(_assemblyPath)
        _plugIn = _adPlugIn.CreateInstanceAndUnwrap(assemblyFilename, _typename)
    End Sub


    'Private Function FindExistingPermissionSet(ByVal psname As String) As PermissionSet
    '    Dim phe As IEnumerator = SecurityManager.PolicyHierarchy
    '    While phe.MoveNext()
    '        Dim pl As PolicyLevel = phe.Current
    '        Dim ps As PermissionSet = pl.GetNamedPermissionSet(psname)
    '        If Not ps Is Nothing Then
    '            Return ps
    '        End If
    '    End While
    '    Return New PermissionSet(Permissions.PermissionState.None)
    'End Function


    Public ReadOnly Property description() As Briefdatenbank.Plugin.Common.PlugInDescription
        Get
            Return _plugIn.Description
        End Get
    End Property

    Public ReadOnly Property assemblyPath() As String
        Get
            Return _assemblyPath
        End Get
    End Property

    Public ReadOnly Property typename() As String
        Get
            Return _typename
        End Get
    End Property


    ' alternative: dont give clients access to the plug-in itself, but rather let the PlugInDescriptor implement IPlugIn.
    ' that way the plug-in instance can change anytime behind the scenes without the client realizing it.
    Public ReadOnly Property plugIn() As Briefdatenbank.Plugin.Common.IPlugIn
        Get
            Return _plugIn
        End Get
    End Property
    Public Sub Entladen()
        If Not _adPlugIn Is Nothing Then
            AppDomain.Unload(_adPlugIn)
        End If
    End Sub
End Class