Public Class BeschreibungAktion
    Implements IAMBeschreibungsElement

    Private m_Text As String = ""
    Private m_Beschreibung As String = ""
    Private m_Checked As Boolean = False

    Private m_VisibleState As VisibleStates = VisibleStates.Enabled
    Private m_MenueVisible As Boolean = True

    Private m_Image As Image
    Public Event Changed() Implements IAMBeschreibungsElement.Changed
    Public Event Aktion()
    Property Text() As String
        Get
            Return m_Text
        End Get
        Set(ByVal value As String)
            If m_Text <> value Then
                m_Text = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Property Beschreibung() As String
        Get
            Return m_Beschreibung
        End Get
        Set(ByVal value As String)
            If m_Beschreibung <> value Then
                m_Beschreibung = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Property Checked() As Boolean
        Get
            Return m_Checked
        End Get
        Set(ByVal value As Boolean)
            If m_Checked <> value Then
                m_Checked = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Property Image() As Image
        Get
            Return m_Image
        End Get
        Set(ByVal value As Image)
            If m_Image IsNot value Then
                m_Image = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Public Sub SetValues(ByVal Text As String, ByVal Beschreibung As String, ByVal VisibleState As VisibleStates, ByVal Image As Image)
        m_Text = Text
        m_Beschreibung = Beschreibung
        m_VisibleState = VisibleState
        m_Image = Image
        RaiseEvent Changed()
    End Sub

    Public Sub New(ByVal Text As String, ByVal Beschreibung As String)
        m_Text = Text
        m_Beschreibung = Beschreibung
    End Sub
    Public Sub New(ByVal Text As String, ByVal Beschreibung As String, ByVal VisibleState As VisibleStates)
        m_Text = Text
        m_Beschreibung = Beschreibung
        m_VisibleState = VisibleState
    End Sub
    Public Sub New(ByVal Text As String, ByVal Beschreibung As String, ByVal VisibleState As VisibleStates, ByVal Image As Image)
        m_Text = Text
        m_Beschreibung = Beschreibung
        m_VisibleState = VisibleState
        m_Image = Image
    End Sub
    Public Overridable Sub DoAction()
        RaiseEvent Aktion()
    End Sub
    Property VisibleState() As VisibleStates Implements IAMBeschreibungsElement.VisibleState
        Get
            Return m_VisibleState
        End Get
        Set(ByVal value As VisibleStates)
            If m_VisibleState <> value Then
                m_VisibleState = value
                RaiseEvent Changed()
            End If
        End Set
    End Property


    Public ReadOnly Property Typ() As AMBeschreibungsElementTypen Implements IAMBeschreibungsElement.Typ
        Get
            Return AMBeschreibungsElementTypen.Aktion
        End Get
    End Property

    'Visible hat Prioritt
    Public Property Visible() As Boolean Implements IAMBeschreibungsElement.MenueVisible
        Get
            Return m_MenueVisible
        End Get
        Set(ByVal value As Boolean)
            If m_MenueVisible <> value Then
                m_MenueVisible = value
                RaiseEvent Changed()
            End If
        End Set
    End Property

    Public Function CreateElemente() As System.Collections.Generic.List(Of ToolStripItem) Implements IAMBeschreibungsElement.CreateElemente
        Dim Liste As New List(Of ToolStripItem)
        Liste.Add(New AktionsToolStripItem(Me))
        Return Liste
    End Function


End Class

