Public Class BeschreibungParent
    Implements IAMBeschreibungsElement

    Private m_Text As String = ""
    Private m_Beschreibung As String = ""

    Private m_VisibleState As VisibleStates = VisibleStates.Enabled
    Private m_MenueVisible As Boolean = True

    Public Event Changed() Implements IAMBeschreibungsElement.Changed
    Private m_Children As List(Of IAMBeschreibungsElement)
    ReadOnly Property Children() As List(Of IAMBeschreibungsElement)
        Get
            Return m_Children
        End Get
    End Property

    Property Text() As String
        Get
            Return m_Text
        End Get
        Set(ByVal value As String)
            If m_Text <> value Then
                m_Text = value
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Property Beschreibung() As String
        Get
            Return m_Beschreibung
        End Get
        Set(ByVal value As String)
            If m_Beschreibung <> value Then
                m_Beschreibung = value
                RaiseEvent Changed()
            End If
        End Set
    End Property

    Public Sub New(ByVal Text As String, ByVal Beschreibung As String)
        m_Text = Text
        m_Beschreibung = Beschreibung
        m_Children = New List(Of IAMBeschreibungsElement)
    End Sub
    Public Sub New(ByVal Text As String, ByVal Beschreibung As String, ByVal VisibleState As VisibleStates)
        m_Text = Text
        m_Beschreibung = Beschreibung
        m_VisibleState = VisibleState
        m_Children = New List(Of IAMBeschreibungsElement)
    End Sub

    Property VisibleState() As VisibleStates Implements IAMBeschreibungsElement.VisibleState
        Get
            Return m_VisibleState
        End Get
        Set(ByVal value As VisibleStates)
            If m_VisibleState <> value Then
                m_VisibleState = value
                RaiseEvent Changed()
            End If
        End Set
    End Property


    Public ReadOnly Property Typ() As AMBeschreibungsElementTypen Implements IAMBeschreibungsElement.Typ
        Get
            Return AMBeschreibungsElementTypen.ParentElement
        End Get
    End Property

    'Visible hat Prioritt
    Public Property Visible() As Boolean Implements IAMBeschreibungsElement.MenueVisible
        Get
            Return m_MenueVisible
        End Get
        Set(ByVal value As Boolean)
            If m_MenueVisible <> value Then
                m_MenueVisible = value
                RaiseEvent Changed()
            End If
        End Set
    End Property

    Public Function CreateElemente() As System.Collections.Generic.List(Of ToolStripItem) Implements IAMBeschreibungsElement.CreateElemente
        Dim Liste As New List(Of ToolStripItem)

        Dim NewPar As New AMToolStripParent(Me)
        For Each el As IAMBeschreibungsElement In m_Children
            NewPar.DropDownItems.AddRange(el.CreateElemente.ToArray)
        Next

        Liste.Add(NewPar)
        Return Liste
    End Function


End Class
