Imports System.Xml
Public Class Anrede
    Implements ICloneable

    Private m_titel As String = ""
    Private m_synonyme As List(Of String)
    Private m_anredemnnlich As String = ""
    Private m_anredeweiblich As String = ""
    Private m_mitNachname As Boolean = True
    Public Event TitelGendert()
    Public Event AnredeMnnlichGendert()
    Public Event AnredeWeiblichGendert()
    Public Sub New()
        m_synonyme = New List(Of String)
    End Sub
    Public Sub New(ByVal XTitel As String, ByVal xAnredemnnlich As String, ByVal xAnredeweiblich As String, ByVal xmitNachname As Boolean)
        m_synonyme = New List(Of String)
        Me.m_titel = XTitel
        Me.m_anredemnnlich = xAnredemnnlich
        Me.m_anredeweiblich = xAnredeweiblich
        Me.m_mitNachname = xmitNachname
    End Sub
    Public Sub New(ByVal Nd As System.Xml.XmlNode)
        m_synonyme = New List(Of String)
        Me.m_titel = Nd.Attributes("Titel").Value
        Me.m_anredemnnlich = Nd.Attributes("Anredemnnlich").Value
        Me.m_anredeweiblich = Nd.Attributes("Anredeweiblich").Value
        Me.m_mitNachname = CBool(Nd.Attributes("MitNachname").Value)
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Synonym" Then
                Me.m_synonyme.Add(xNd.Attributes("Text").Value)
            End If
        Next
    End Sub
    Property Titel() As String
        Get
            Return m_titel
        End Get
        Set(ByVal Value As String)
            If Value = "" Then
                m_titel = "???"
            Else
                m_titel = Value
            End If
            m_anredemnnlich = "Sehr geehrter Herr " & m_titel
            m_anredeweiblich = "Sehr geehrte Frau " & m_titel
            RaiseEvent TitelGendert()
        End Set
    End Property
    ReadOnly Property Synonyme() As List(Of String)
        Get
            Return m_synonyme
        End Get
    End Property
    Property AnredeMnnlich() As String
        Get
            Return m_anredemnnlich
        End Get
        Set(ByVal Value As String)
            m_anredemnnlich = Value
            RaiseEvent AnredeMnnlichGendert()
        End Set
    End Property
    Property AnredeWeiblich() As String
        Get
            Return m_anredeweiblich
        End Get
        Set(ByVal Value As String)
            m_anredeweiblich = Value
            RaiseEvent AnredeWeiblichGendert()
        End Set
    End Property
    Property MitNachname() As Boolean
        Get
            Return m_mitNachname
        End Get
        Set(ByVal Value As Boolean)
            m_mitNachname = Value
            RaiseEvent TitelGendert()
        End Set
    End Property
    Public Function MusterAnredeMnnlich() As String
        Dim ZM As String
        If Me.m_mitNachname Then
            ZM = m_anredemnnlich & " Mustermann,"
        Else
            ZM = m_anredemnnlich & ","
        End If
        Return ZM
    End Function
    Public Function MusterAnredeWeiblich() As String
        Dim ZM As String
        If Me.m_mitNachname Then
            ZM = m_anredeweiblich & " Mustermann,"
        Else
            ZM = m_anredeweiblich & ","
        End If
        Return ZM
    End Function
    Public Overrides Function ToString() As String
        Return m_titel
    End Function
    Public Sub XMLSchreiben(ByVal writer As System.Xml.XmlTextWriter)
        writer.WriteAttributeString("Titel", Me.m_titel)
        writer.WriteAttributeString("Anredemnnlich", Me.m_anredemnnlich)
        writer.WriteAttributeString("Anredeweiblich", Me.m_anredeweiblich)
        writer.WriteAttributeString("MitNachname", Me.m_mitNachname.ToString)
        For Each Txt As String In Me.Synonyme
            writer.WriteStartElement("Synonym")
            writer.WriteAttributeString("Text", Txt)
            writer.WriteEndElement()
        Next
    End Sub

    Public Function Clone() As Object Implements System.ICloneable.Clone
        Dim NewAnrede As New Anrede

        NewAnrede.Titel = Me.Titel
        For Each Syn As String In Me.Synonyme
            NewAnrede.Synonyme.Add(Syn)
        Next
        NewAnrede.AnredeMnnlich = m_anredemnnlich
        NewAnrede.AnredeWeiblich = m_anredeweiblich
        NewAnrede.MitNachname = m_mitNachname

        Return NewAnrede
    End Function
End Class
