Imports System.Xml
Public Class Brief
    Inherits BriefInfo
    Implements IPfadelement

#Region " Private Variablen und Properties "
    Public Overrides ReadOnly Property Typ() As BriefInfoTypen
        Get
            Return BriefInfoTypen.Brief
        End Get
    End Property
    Public Overrides ReadOnly Property Contents() As BriefInfoContents
        Get
            Return BriefInfoContents.Pfad Or BriefInfoContents.Reeditable
        End Get
    End Property
    Private m_Pfad As String = ""
    Property Pfad() As String Implements IPfadelement.Pfad
        Get
            Return m_Pfad
        End Get
        Set(ByVal value As String)
            If m_Pfad <> value Then
                m_Pfad = value
                Aenderung_Melden()
            End If
        End Set
    End Property
#End Region

#Region " Konstruktor und Speichern "
    Public Sub New()

    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        MyBase.New(Nd)
        m_Pfad = Nd.Attributes("Pfad").Value
        'If m_Pfad.ToLower.EndsWith("docdoc.doc") Then
        '    m_Pfad = m_Pfad.Replace("docdoc", "")
        'End If
        'If m_Pfad.ToLower.EndsWith(".doc") Then
        '    m_Pfad = m_Pfad.Substring(0, m_Pfad.Length - 4)
        'End If
        'If Not (m_Pfad.ToLower.EndsWith(".doc") Or m_Pfad.ToLower.EndsWith(".docx")) Then
        '    m_Pfad &= ".doc"
        'End If
    End Sub
    Public Overrides Sub XMLSchreiben(ByVal writer As XmlTextWriter)
        MyBase.XMLSchreiben(writer)
        writer.WriteAttributeString("Pfad", m_Pfad)
    End Sub
#End Region

#Region " Cloning "
    Public Overrides Function Clone() As Object
        Dim Brf As New Brief
        Brf.Betreff = Me.Betreff
        Brf.Datum = Me.Datum
        Brf.Pfad = Me.Pfad
        Return Brf
    End Function
    Public Overrides Sub ReadCloneValues(ByVal ClonedObject As Object)
        Dim Brf As Brief = DirectCast(ClonedObject, Brief)
        Me.Betreff = Brf.Betreff
        Me.Datum = Brf.Datum
        Me.Pfad = Brf.Pfad
    End Sub
#End Region

#Region " ListViewItem "
    Public Overrides Sub ListviewItem_Ausfuellen(ByVal LVI As BriefListViewItem)
        LVI.Text = Format(Me.Datum, "d")
        LVI.SubItems(1).Text = ""
        LVI.SubItems(2).Text = Me.Betreff
        LVI.ImageIndex = 1
    End Sub
#End Region

End Class

