Imports System.Xml
Public Class Rechnung
    Inherits Brief
    Implements IGeldelement
    Implements IRechnungsNummernElement


#Region " Private Variablen und Properties "
    Private m_Geldbetrag As Decimal = 0D
    Private m_Rechnungsnummer As String = ""
    Public Property Betrag() As Decimal Implements IGeldelement.Geldbetrag
        Get
            Return m_Geldbetrag
        End Get
        Set(ByVal value As Decimal)
            If m_Geldbetrag <> value Then
                m_Geldbetrag = value
                MyBase.Aenderung_Melden()
            End If
        End Set
    End Property
    Property Rechnungsnummer() As String Implements IRechnungsNummernElement.Rechnungsnummer
        Get
            Return m_Rechnungsnummer
        End Get
        Set(ByVal value As String)
            If m_Rechnungsnummer <> value Then
                m_Rechnungsnummer = value
                MyBase.Aenderung_Melden()
            End If
        End Set
    End Property
    Public Overrides ReadOnly Property Typ() As BriefInfoTypen
        Get
            Return BriefInfoTypen.Rechnung
        End Get
    End Property
    Public Overrides ReadOnly Property Contents() As BriefInfoContents
        Get
            Return BriefInfoContents.Pfad Or BriefInfoContents.Reeditable Or BriefInfoContents.Geld Or BriefInfoContents.RechnungsNummer
        End Get
    End Property
#End Region

#Region " Konstruktor und Speichern "
    Public Sub New()

    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        MyBase.New(Nd)
        m_Geldbetrag = CDec(Nd.Attributes("Betrag").Value)
        m_Rechnungsnummer = Nd.Attributes("RechnungsNr").Value
    End Sub
    Public Overrides Sub XMLSchreiben(ByVal writer As XmlTextWriter)
        MyBase.XMLSchreiben(writer)
        writer.WriteAttributeString("Betrag", m_Geldbetrag.ToString)
        writer.WriteAttributeString("RechnungsNr", m_Rechnungsnummer)
    End Sub
#End Region

#Region " Cloning "
    Public Overrides Function Clone() As Object
        Dim Rchng As New Rechnung
        Rchng.Betreff = Me.Betreff
        Rchng.Datum = Me.Datum
        Rchng.Pfad = Me.Pfad
        Rchng.Betrag = Me.Betrag
        Return Rchng
    End Function
    Public Overrides Sub ReadCloneValues(ByVal ClonedObject As Object)
        Dim Rchng As Rechnung = DirectCast(ClonedObject, Rechnung)
        Me.Betreff = Rchng.Betreff
        Me.Datum = Rchng.Datum
        Me.Pfad = Rchng.Pfad
        Me.Betrag = Rchng.Betrag
    End Sub
#End Region

#Region " ListViewItem "
    Public Overrides Sub ListviewItem_Ausfuellen(ByVal LVI As BriefListViewItem)
        LVI.Text = Format(Me.Datum, "d")
        LVI.SubItems(1).Text = Format(m_Geldbetrag, "c")
        LVI.SubItems(2).Text = Me.Rechnungsnummer & " " & Me.Betreff
        LVI.ImageIndex = 2
    End Sub
#End Region


End Class


