Public Class BriefInfoComparer
    Implements IComparer(Of BriefInfo)

    '   'alles wird nach Datum sortiert, nur wichtige Infos erscheinen ganz oben
    Public Function Compare(ByVal x As BriefInfo, ByVal y As BriefInfo) As Integer Implements System.Collections.Generic.IComparer(Of BriefInfo).Compare
        'Primr wre die Wichtigkeit einer Info (wichtige Infos werden nach oben gesetzt)
        'unwichtige Infos reihen sich normal in die Reihenfolge ein

        Dim XNachOben As Boolean = False
        Dim YNachOben As Boolean = False

        If x.Typ = BriefInfoTypen.Info Then
            Dim Inf As Info = CType(x, Info)
            If Inf.Wichtig Then XNachOben = True
        End If
        If y.Typ = BriefInfoTypen.Info Then
            Dim Inf As Info = CType(y, Info)
            If Inf.Wichtig Then YNachOben = True
        End If

        If XNachOben = YNachOben Then
            Return y.Datum.CompareTo(x.Datum)
        ElseIf XNachOben Then
            Return -1
        ElseIf YNachOben Then
            Return 1
        End If

    End Function


End Class
