Imports System.Xml
Public Class DateiVerwalter
    Private m_PreviousFiles As List(Of String)
    Private m_Pfad As String = ""

    Private m_ActiveDatensammlungPfad As String = ""
    Private m_ActiveDatensammlung As Datensammlung

    Public Sub New()
        m_PreviousFiles = New List(Of String)
        m_Pfad = Application.StartupPath & "\Dateien.xml"
        XML_Lesen()

        If m_PreviousFiles.Count = 0 Then
            Dim DirPath As String = Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\Briefe"
            If Not IO.Directory.Exists(DirPath) Then
                IO.Directory.CreateDirectory(DirPath)
            End If
            If Not IO.Directory.Exists(DirPath & "\Vorlagen") Then
                IO.Directory.CreateDirectory(DirPath & "\Vorlagen")
            End If
            m_PreviousFiles.Add(DirPath & "\Briefdatenbank.bdbxml")
        End If
    End Sub
    ReadOnly Property PreviousFiles() As List(Of String)
        Get
            Return m_PreviousFiles
        End Get
    End Property

    Public Function CreateDatenSammlung(ByVal Pfad As String, ByVal Plugins As List(Of Briefdatenbank.Plugin.Common.PlugInDescription), ByVal Serv As Briefdatenbank.Service.BriefBearbeitungsService) As Datensammlung
        If m_ActiveDatensammlungPfad = "" Then
            m_ActiveDatensammlungPfad = Pfad

            If m_PreviousFiles.Contains(m_ActiveDatensammlungPfad) Then
                m_PreviousFiles.Remove(m_ActiveDatensammlungPfad)
            End If
            m_PreviousFiles.Insert(0, m_ActiveDatensammlungPfad)


            m_ActiveDatensammlung = New Datensammlung(m_ActiveDatensammlungPfad, Plugins, Serv)
            Dim DirName As String = IO.Path.GetDirectoryName(m_Pfad)
            If Not IO.Directory.Exists(DirName & "\Vorlagen") Then
                IO.Directory.CreateDirectory(DirName & "\Vorlagen")
            End If

            Return m_ActiveDatensammlung
        ElseIf m_ActiveDatensammlungPfad = Pfad Then
            Return m_ActiveDatensammlung
        Else
            m_ActiveDatensammlung.Speichern()
            m_ActiveDatensammlungPfad = Pfad

            If m_PreviousFiles.Contains(m_ActiveDatensammlungPfad) Then
                m_PreviousFiles.Remove(m_ActiveDatensammlungPfad)
            End If
            m_PreviousFiles.Insert(0, m_ActiveDatensammlungPfad)

            m_ActiveDatensammlung = New Datensammlung(m_ActiveDatensammlungPfad, Plugins, Serv)
            Dim DirName As String = IO.Path.GetDirectoryName(m_Pfad)
            If Not IO.Directory.Exists(DirName & "\Vorlagen") Then
                IO.Directory.CreateDirectory(DirName & "\Vorlagen")
            End If

            Return m_ActiveDatensammlung
        End If
    End Function


    Public Sub XML_Lesen()
        If IO.File.Exists(m_Pfad) Then
            Dim reader As XmlTextReader = New XmlTextReader(m_Pfad)

            reader.WhitespaceHandling = WhitespaceHandling.None
            Dim xmlDoc As XmlDocument = New XmlDocument
            xmlDoc.Load(reader)
            reader.Close()
            Dim xnod As XmlNode = xmlDoc.DocumentElement
            Dim xKn As XmlNode

            Dim FileName As String = ""

            For Each xKn In xnod.ChildNodes
                If xKn.Name = "File" Then
                    FileName = xKn.Attributes("Path").Value
                    If IO.File.Exists(FileName) Then
                        m_PreviousFiles.Add(FileName)
                    End If
                End If
            Next
        End If
    End Sub
    Public Sub XML_Speichern()

        Dim writer As XmlTextWriter = New XmlTextWriter(m_Pfad, System.Text.Encoding.UTF8)
        writer.WriteStartDocument(True)

        writer.WriteStartElement("Elemente")

        For Each txt As String In m_PreviousFiles
            writer.WriteStartElement("File")
            writer.WriteAttributeString("Path", txt)
            writer.WriteEndElement()
        Next

        writer.WriteEndElement()
        writer.WriteEndDocument()
        writer.Close()
    End Sub
End Class
