Imports System.Xml
Public Class Datensammlung
    Private m_Pfad As String = ""
    Private m_SpeicherDirectory As String = ""
    Private m_VorlagenDirectory As String = ""

    Private m_Plugins As List(Of Briefdatenbank.Plugin.Common.PlugInDescription)
    Private m_Serv As Briefdatenbank.Service.BriefBearbeitungsService

    Private WithEvents m_Vorlagen As Dokumentenvorlagenliste
    Private WithEvents m_Anreden As Anredeliste
    Private WithEvents m_Adressen As Adressliste
    Private WithEvents m_Titel As Titelliste

    Private m_BriefInfoBearbeiter As SelectedBriefInfoliste

    Property Anreden() As Anredeliste
        Get
            Return m_Anreden
        End Get
        Set(ByVal value As Anredeliste)
            m_Anreden = value
            m_Adressen.Anreden = value
        End Set
    End Property
    ReadOnly Property VorlagenDirectory() As String
        Get
            Return m_VorlagenDirectory
        End Get
    End Property
    ReadOnly Property BriefeDirectory() As String
        Get
            Return m_SpeicherDirectory
        End Get
    End Property
    ReadOnly Property BriefInfoBearbeiter() As SelectedBriefInfoliste
        Get
            Return m_BriefInfoBearbeiter
        End Get
    End Property


    ReadOnly Property Vorlagen() As Dokumentenvorlagenliste
        Get
            Return m_Vorlagen
        End Get
    End Property
    ReadOnly Property Titel() As Titelliste
        Get
            Return m_Titel
        End Get
    End Property

    ReadOnly Property Adressen() As Adressliste
        Get
            Return m_Adressen
        End Get
    End Property

    Public Function CreateAdressContextMenuStrip() As System.Windows.Forms.ContextMenuStrip
        Dim CMS As New ContextMenuStrip
        CMS.Items.AddRange(m_Adressen.CreateMenue.ToArray)
        Return CMS
    End Function
    Public Function CreateBriefContextMenuStrip() As System.Windows.Forms.ContextMenuStrip
        Dim CMS As New ContextMenuStrip
        CMS.Items.AddRange(m_BriefInfoBearbeiter.CreateMenue.ToArray)
        Return CMS
    End Function
    Public Function CreateBearbeitenMenuStrip() As System.Windows.Forms.ToolStripMenuItem
        Dim BearbeitenMenuStrip As New ToolStripMenuItem("Bearbeiten")
        BearbeitenMenuStrip.DropDownItems.AddRange(m_Adressen.CreateMenue.ToArray)
        BearbeitenMenuStrip.DropDownItems.Add(New ToolStripSeparator)
        BearbeitenMenuStrip.DropDownItems.AddRange(m_BriefInfoBearbeiter.CreateMenue.ToArray)
        Return BearbeitenMenuStrip
    End Function

    Public Sub New(ByVal Pfad As String, ByVal Plugins As List(Of Briefdatenbank.Plugin.Common.PlugInDescription), ByVal Serv As Briefdatenbank.Service.BriefBearbeitungsService)
        m_Pfad = Pfad
        m_Plugins = Plugins
        m_Serv = Serv

        m_SpeicherDirectory = IO.Path.GetDirectoryName(m_Pfad)
        m_VorlagenDirectory = m_SpeicherDirectory & "\Vorlagen"

        m_Vorlagen = New Dokumentenvorlagenliste(m_VorlagenDirectory)

        If IO.File.Exists(m_Pfad) Then
            Dim reader As XmlTextReader = New XmlTextReader(m_Pfad)

            reader.WhitespaceHandling = WhitespaceHandling.None
            Dim xmlDoc As XmlDocument = New XmlDocument
            xmlDoc.Load(reader)
            reader.Close()
            Dim xnod As XmlNode = xmlDoc.DocumentElement
            Dim xKn As XmlNode

            For Each xKn In xnod.ChildNodes
                If xKn.Name = "ListeAnreden" Then
                    m_Anreden = New Anredeliste(xKn)
                    Exit For
                End If
            Next
            If m_Anreden Is Nothing Then m_Anreden = New Anredeliste

            For Each xKn In xnod.ChildNodes
                If xKn.Name = "ListeAdressen" Then
                    m_Adressen = New Adressliste(xKn, m_Anreden)
                    Exit For
                End If
            Next

            For Each xKn In xnod.ChildNodes
                If xKn.Name = "Liste_Titel" Then
                    m_Titel = New Titelliste(xKn)
                    Exit For
                End If
            Next
            If m_Titel Is Nothing Then m_Titel = New Titelliste

        Else
            m_Anreden = New Anredeliste
            m_Adressen = New Adressliste(m_Anreden)
            m_Titel = New Titelliste
        End If

        m_BriefInfoBearbeiter = New SelectedBriefInfoliste(m_Adressen, m_Plugins, m_Serv, m_VorlagenDirectory, m_SpeicherDirectory)
        'm_BriefInfoBearbeiter.Adresse = m_Adressen.SelectedElement
    End Sub

    Public Sub Speichern()

        Dim writer As XmlTextWriter = New XmlTextWriter(m_Pfad, System.Text.Encoding.UTF8)
        writer.WriteStartDocument(True)

        writer.WriteStartElement("Elemente")

        writer.WriteStartElement("ListeAdressen")
        m_Adressen.WriteXML(writer)
        writer.WriteEndElement()

        writer.WriteStartElement("ListeAnreden")
        m_Anreden.WriteXML(writer)
        writer.WriteEndElement()


        writer.WriteStartElement("Liste_Titel")
        m_Titel.WriteXML(writer)
        writer.WriteEndElement()

        writer.WriteStartElement("Version")
        writer.WriteAttributeString("Nr", "2")
        writer.WriteEndElement()

        writer.WriteEndElement()
        writer.WriteEndDocument()
        writer.Close()
    End Sub

End Class
