Imports System.Xml
Public Class Anredeliste
    Inherits SelectedObjektliste(Of Anrede)
    Overrides Sub SetSelectedElement(ByVal Value As Anrede, ByVal Sender As Object)
        If m_SelectedElement IsNot Value Then
            m_SelectedElement = Value
            SelectedEventAusloesen(Value, Sender)
        End If
    End Sub

    Public Sub New()
        Standard_Anreden_Herstellen()
        SetSelectedElement(Me.Item(0), Me)
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        For Each Kn As XmlNode In Nd.ChildNodes
            If Kn.Name = "Anrede" Then
                Me.Add(New Anrede(Kn))
            End If
        Next
        If Me.Count = 0 Then
            Standard_Anreden_Herstellen()
        End If
        SetSelectedElement(Me.Item(0), Me)
    End Sub


    Public Sub WriteXML(ByVal Writer As XmlTextWriter)
        For Each A As Anrede In Me
            Writer.WriteStartElement("Anrede")
            A.XMLSchreiben(Writer)
            Writer.WriteEndElement()
        Next
    End Sub

    Public Sub Standard_Anreden_Herstellen()
        Me.Clear()

        Dim A As Anrede
        A = New Anrede("Professor", "Sehr geehrter Herr Professor", "Sehr geehrte Frau Professor", True)
        A.Synonyme.Add("Prof.")
        A.Synonyme.Add("Professor")
        A.Synonyme.Add("Professorin")
        Me.Add(A)

        A = New Anrede("Chefarzt", "Sehr geehrter Herr Chefarzt", "Sehr geehrte Frau Chefarzt", True)
        A.Synonyme.Add("ChA")
        A.Synonyme.Add("Chefarzt")
        A.Synonyme.Add("Chefrztin")
        A.Synonyme.Add("Ch")
        A.Synonyme.Add("ChA.")
        A.Synonyme.Add("Ch.")
        Me.Add(A)
        A = New Anrede("Oberarzt", "Sehr geehrter Herr Oberarzt", "Sehr geehrte Frau Oberarzt", True)
        A.Synonyme.Add("OA")
        A.Synonyme.Add("O")
        A.Synonyme.Add("OA.")
        A.Synonyme.Add("O.")
        A.Synonyme.Add("Oberarzt")
        A.Synonyme.Add("Oberrztin")
        Me.Add(A)
        A = New Anrede("Dozent", "Sehr geehrter Herr Dozent", "Sehr geehrte Frau Dozent", True)

        A.Synonyme.Add("Doz.")
        A.Synonyme.Add("Dozent")
        A.Synonyme.Add("Dozentin")
        Me.Add(A)
        A = New Anrede("Privatdozent", "Sehr geehrter Herr Privatdozent", "Sehr geehrte Frau Privatdozent", True)

        A.Synonyme.Add("PD")
        A.Synonyme.Add("Privatdozentin")
        A.Synonyme.Add("P.D.")
        A.Synonyme.Add("Privat-Dozent")
        A.Synonyme.Add("Priv.Doz.")
        A.Synonyme.Add("Priv.-Doz.")
        A.Synonyme.Add("Priv-Doz.")
        A.Synonyme.Add("Priv-Doz")
        A.Synonyme.Add("Privatdozent")
        Me.Add(A)
        A = New Anrede("Medizinalrat", "Sehr geehrter Herr Medizinalrat", "Sehr geehrte Frau Medizinalrat", True)

        A.Synonyme.Add("MR")
        A.Synonyme.Add("Medizinalrat")
        Me.Add(A)
        A = New Anrede("Sanittsrat", "Sehr geehrter Herr Sanittsrat", "Sehr geehrte Frau Sanittsrat", True)

        A.Synonyme.Add("SR")
        A.Synonyme.Add("Sanittsrtin")
        A.Synonyme.Add("Sanittsrat")
        Me.Add(A)
        A = New Anrede("Doktor", "Sehr geehrter Herr Dr.", "Sehr geehrte Frau Dr.", True)

        A.Synonyme.Add("Dr.")
        A.Synonyme.Add("Doktor")
        Me.Add(A)
        A = New Anrede("Dezernent", "Sehr geehrter Herr Dezernent", "Sehr geehrte Frau Dezernentin", True)

        A.Synonyme.Add("Dez.")
        A.Synonyme.Add("Dezernent")
        A.Synonyme.Add("Dezernentin")
        Me.Add(A)
        A = New Anrede("Richter", "Sehr geehrter Herr Richter", "Sehr geehrte Frau Richterin", True)

        A.Synonyme.Add("Richter")
        A.Synonyme.Add("Richterin")
        Me.Add(A)
        A = New Anrede("Rechtsanwalt", "Sehr geehrter Herr Rechtsanwalt", "Sehr geehrte Frau Rechtsanwalt", True)

        A.Synonyme.Add("Rechtsanwalt")
        A.Synonyme.Add("Rechtsanwltin")
        A.Synonyme.Add("RA")
        A.Synonyme.Add("RA.")
        Me.Add(A)
        A = New Anrede("Arzt", "Sehr geehrter Herr Kollege", "Sehr geehrte Frau Kollegin", False)

        A.Synonyme.Add("Arzt")
        A.Synonyme.Add("arzt")
        A.Synonyme.Add("rztin")
        A.Synonyme.Add("rztin")
        A.Synonyme.Add("DM")
        A.Synonyme.Add("Dipl.-med.")
        A.Synonyme.Add("dipl.-med.")
        A.Synonyme.Add("dipl-med")
        A.Synonyme.Add("dipl.med.")
        A.Synonyme.Add("Dipl.med.")
        A.Synonyme.Add("Dipl-med.")
        A.Synonyme.Add("Dipl-med")
        A.Synonyme.Add("Internist")
        A.Synonyme.Add("Allgemeinmed")
        Me.Add(A)
        A = New Anrede("Direktor", "Sehr geehrter Herr Direktor", "Sehr geehrte Frau Direktor", True)

        A.Synonyme.Add("Direktorin")
        A.Synonyme.Add("Dir.")
        A.Synonyme.Add("Direktor")
        Me.Add(A)
        A = New Anrede("Pastor", "Sehr geehrter Herr Pastor", "Sehr geehrte Frau Pastorin", False)

        A.Synonyme.Add("Pastor")
        A.Synonyme.Add("Pastorin")
        Me.Add(A)
        A = New Anrede("Pfarrer", "Sehr geehrter Herr Pfarrer", "Sehr geehrte Frau Pfarrer", True)

        A.Synonyme.Add("Pfarrer")
        A.Synonyme.Add("Pfarrerin")
        Me.Add(A)

    End Sub

End Class
