Imports System.Xml
Public Class BriefInfoListe
    Inherits List(Of BriefInfo)
    Private m_Parent As Adresse

    Public Sub New(ByVal Parent As Adresse)
        m_Parent = Parent
    End Sub
    Public Sub New(ByVal Parent As Adresse, ByVal Nd As XmlNode)
        m_Parent = Parent

        For Each xNd As XmlNode In Nd.ChildNodes
            Select Case xNd.Name
                Case "Info"
                    Me.Add(New Info(xNd))
                Case "Brief"
                    Me.Add(New Brief(xNd))
                Case "Rechnung"
                    Me.Add(New Rechnung(xNd))
                Case "Mahnung"
                    Me.Add(New Mahnung(xNd))
                Case "Zahlungseingang", "Zahlung"
                    Me.Add(New Zahlung(xNd))
            End Select
        Next
    End Sub
#Region " XML lesen / schreiben "
    Public Sub XMLSchreiben(ByVal writer As System.Xml.XmlTextWriter)
        For Each Inf As BriefInfo In Me
            Select Case Inf.Typ
                Case BriefInfoTypen.Brief
                    writer.WriteStartElement("Brief")
                Case BriefInfoTypen.Info
                    writer.WriteStartElement("Info")
                Case BriefInfoTypen.Mahnung
                    writer.WriteStartElement("Mahnung")
                Case BriefInfoTypen.Rechnung
                    writer.WriteStartElement("Rechnung")
                Case BriefInfoTypen.Zahlung
                    writer.WriteStartElement("Zahlung")
            End Select
            Inf.XMLSchreiben(writer)
            writer.WriteEndElement()
        Next
    End Sub
#End Region

End Class
