Public MustInherit Class SelectedObjektliste(Of T)
    Inherits List(Of T)
    Protected Friend m_SelectedElement As T
    Public Event ElementSelectedChanged(ByVal NewSelectedElement As T, ByVal Sender As Object)
    Public Event ElementAdded(ByVal AddedElement As T)
    Public Event ElementRemoved(ByVal RemovedElement As T)

    ReadOnly Property SelectedElement() As T
        Get
            Return m_SelectedElement
        End Get
    End Property
    Public Sub AddAndSelect(ByVal NewElement As T)
        Me.Add(NewElement)
        RaiseEvent ElementAdded(NewElement)
        Me.SetSelectedElement(NewElement, Me)
    End Sub
    Public Overridable Sub RemoveSelected()
        If m_SelectedElement IsNot Nothing Then
            Dim ElementToRemove As T = m_SelectedElement
            Dim Idx As Integer = Me.IndexOf(m_SelectedElement) - 1
            Me.Remove(m_SelectedElement)
            If Idx < 0 Then
                Idx = 0
            End If
            If Me.Count > 0 Then
                SetSelectedElement(Me.Item(Idx), Me)
            Else
                SetSelectedElement(Nothing, Me)
            End If
            RaiseEvent ElementRemoved(ElementToRemove)
        End If
    End Sub

    MustOverride Sub SetSelectedElement(ByVal Value As T, ByVal Sender As Object)

    Protected Friend Sub SelectedEventAusloesen(ByVal NewSelectedElement As T, ByVal Sender As Object)
        RaiseEvent ElementSelectedChanged(NewSelectedElement, Sender)
    End Sub

 
End Class
