Public Class Adessauswaehler
    Private m_Items As List(Of AdressListViewItem)
    Private WithEvents m_Adressliste As SelectedObjektliste(Of Adresse)

    Private m_SuchSuppress As Boolean = False
    Private m_UnSortedFlag As Boolean = False

    Private WithEvents m_SelectedLVI As AdressListViewItem
    Public Event SuchEinschraenkungVorhanden(ByVal Sucheeingeschraenkt As Boolean)

    Private Sub Adessauswaehler_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Leave
        AdresseinschraenkungTextBox.Text = ""
        If m_UnSortedFlag Then
            m_Items.Sort(New AdressLVIComparer)
            m_UnSortedFlag = False
            ListViewNeuFllen()
            SetSucheinschraenkung(False)
        End If
    End Sub

    Private Sub Adessauswaehler_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim IL_Personen As New ImageList()
        IL_Personen.ImageSize = New Size(14, 14)
        IL_Personen.Images.Add(My.Resources.unpers)
        IL_Personen.Images.Add(My.Resources.Mann)
        IL_Personen.Images.Add(My.Resources.Frau)
        Me.ListViewAdressAuswahl.SmallImageList = IL_Personen

        'm_AlleAnzeigenAktion = New BeschreibungAktion("Alle anzeigen", "Hebt die Einschrnkung bei der Adressuche wieder auf.", VisibleStates.Invisible)

    End Sub
    'ReadOnly Property AlleAnzeigenAktion() As BeschreibungAktion
    '    Get
    '        Return m_AlleAnzeigenAktion
    '    End Get
    'End Property
    WriteOnly Property Adressliste() As SelectedObjektliste(Of Adresse)
        Set(ByVal value As SelectedObjektliste(Of Adresse))
            If m_Adressliste IsNot value Then
                m_Adressliste = value
                StartAuffuellung()
            End If
        End Set
    End Property
    Private Sub StartAuffuellung()
        m_UnSortedFlag = False
        m_Items = New List(Of AdressListViewItem)
        If m_Adressliste IsNot Nothing Then
            For Each Adr As Adresse In m_Adressliste
                m_Items.Add(New AdressListViewItem(Adr))
            Next
        End If
        m_Items.Sort(New AdressLVIComparer)

        Me.ListViewAdressAuswahl.Items.Clear()
        Me.ListViewAdressAuswahl.Items.AddRange(m_Items.ToArray)

        If m_Adressliste.SelectedElement Is Nothing Then
            ListViewAdressAuswahl.Items(0).Selected = True
        Else
            Dim SelAdr As Adresse = m_Adressliste.SelectedElement
            For Each Itm As AdressListViewItem In ListViewAdressAuswahl.Items
                If Itm.Adresse Is SelAdr Then
                    Itm.Selected = True
                    Exit For
                End If
            Next
        End If
        m_SuchSuppress = True
        AdresseinschraenkungTextBox.Text = ""
        m_SuchSuppress = False

        SetSucheinschraenkung(False)
    End Sub
    Private Sub ListViewAdressAuswahl_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListViewAdressAuswahl.SelectedIndexChanged
        If ListViewAdressAuswahl.SelectedItems.Count > 0 Then
            Dim LVI As AdressListViewItem = ListViewAdressAuswahl.SelectedItems(0)
            m_SelectedLVI = LVI
            m_Adressliste.SetSelectedElement(LVI.Adresse, Me)
        End If
    End Sub

    'Private m_AlleAnzeigenAktion As BeschreibungAktion

    Private m_SucheEingeschraenkt As Boolean = False
    Private Sub SetSucheinschraenkung(ByVal Eingeschraenkt As Boolean)
        If m_SucheEingeschraenkt <> Eingeschraenkt Then
            m_SucheEingeschraenkt = Eingeschraenkt

            If m_SucheEingeschraenkt Then
                Me.ButtonAlleAnzeigen.Text = "Alle"
                'm_AlleAnzeigenAktion.VisibleState = VisibleStates.Enabled
                RaiseEvent SuchEinschraenkungVorhanden(True)
            Else
                Me.ButtonAlleAnzeigen.Text = "Suchen"
                'm_AlleAnzeigenAktion.VisibleState = VisibleStates.Invisible
                RaiseEvent SuchEinschraenkungVorhanden(False)
            End If

        End If
    End Sub

    Private Sub AdresseinschraenkungTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AdresseinschraenkungTextBox.TextChanged
        If m_SuchSuppress Then Exit Sub

        Dim Suchtext As String = AdresseinschraenkungTextBox.Text.Trim
        If Suchtext = "" Then
            If m_SucheEingeschraenkt Then
                ListViewNeuFllen()
                SetSucheinschraenkung(False)
            End If
        Else
            ListViewNeuFllen(Suchtext)
            SetSucheinschraenkung(True)
        End If

        If ListViewAdressAuswahl.SelectedItems.Count > 0 Then
            Dim SelItem As AdressListViewItem = ListViewAdressAuswahl.SelectedItems(0)
            SelItem.EnsureVisible()
        End If
    End Sub
    Public Sub Schuldner_Suchen()

        If m_UnSortedFlag Then
            m_Items.Sort(New AdressLVIComparer)
            m_UnSortedFlag = False
        End If

        Dim TmpListe As New List(Of AdressListViewItem)
        Dim Schulden As Decimal = 0D

        For Each LVI As AdressListViewItem In m_Items
            Schulden = 0D
            For Each BI As BriefInfo In LVI.Adresse.Briefe
                If (BI.Contents And BriefInfoContents.Geld) <> 0 Then
                    Dim GE As IGeldelement = BI
                    Schulden += GE.Geldbetrag
                End If
            Next
            If Schulden < 0D Then
                TmpListe.Add(LVI)
            End If
        Next

        If TmpListe.Count = 0 Then
            MessageBox.Show("Keine Schuldner vorhanden.", "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        Else
            m_SuchSuppress = True
            SetSucheinschraenkung(False)
            Me.AdresseinschraenkungTextBox.Text = "Schuldner suchen"

            ListViewAdressAuswahl.BeginUpdate()
            ListViewAdressAuswahl.Items.Clear()
            ListViewAdressAuswahl.Items.AddRange(TmpListe.ToArray)

            ListViewAdressAuswahl.EndUpdate()

            m_SuchSuppress = False


            ListViewAdressAuswahl.Items(0).Selected = True
            ListViewAdressAuswahl.Items(0).EnsureVisible()

            SetSucheinschraenkung(True)
        End If

    End Sub
    Public Sub Wichtige_Infos_Suchen()

        If m_UnSortedFlag Then
            m_Items.Sort(New AdressLVIComparer)
            m_UnSortedFlag = False
        End If

        Dim TmpListe As New List(Of AdressListViewItem)

        For Each LVI As AdressListViewItem In m_Items
            For Each BI As BriefInfo In LVI.Adresse.Briefe
                If (BI.Contents And BriefInfoContents.Wichtigkeit) <> 0 Then
                    Dim WI As IWichtigkeitselement = BI
                    If WI.Wichtig Then
                        TmpListe.Add(LVI)
                        Exit For
                    End If
                End If
            Next
           
        Next

        If TmpListe.Count = 0 Then
            MessageBox.Show("Keine als wichtig markierten Infos vorhanden.", "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        Else
            m_SuchSuppress = True
            SetSucheinschraenkung(False)
            Me.AdresseinschraenkungTextBox.Text = "Wichtige Infos suchen"

            ListViewAdressAuswahl.BeginUpdate()
            ListViewAdressAuswahl.Items.Clear()
            ListViewAdressAuswahl.Items.AddRange(TmpListe.ToArray)

            ListViewAdressAuswahl.EndUpdate()

            m_SuchSuppress = False


            ListViewAdressAuswahl.Items(0).Selected = True
            ListViewAdressAuswahl.Items(0).EnsureVisible()

            SetSucheinschraenkung(True)
        End If

    End Sub

    Public Sub RechnungsNummer_Suchen()
        Dim frm As New frm_InputBox("Bitte Rechnungsnummer angeben:", "", "Briefdatenbank")
        If frm.ShowDialog = DialogResult.OK Then
            Dim RechnungsNr As String = frm.TextBoxWert.Text.Trim
            If RechnungsNr <> "" Then

                If m_UnSortedFlag Then
                    m_Items.Sort(New AdressLVIComparer)
                    m_UnSortedFlag = False
                End If

                Dim TmpListe As New List(Of AdressListViewItem)

                For Each LVI As AdressListViewItem In m_Items
                    For Each BI As BriefInfo In LVI.Adresse.Briefe
                        If (BI.Contents And BriefInfoContents.RechnungsNummer) <> 0 Then
                            Dim RE As IRechnungsNummernElement = BI
                            If RE.Rechnungsnummer.IndexOf(RechnungsNr) > -1 Then
                                TmpListe.Add(LVI)
                                Exit For
                            End If
                        End If
                    Next
                Next

                If TmpListe.Count = 0 Then
                    MessageBox.Show("Keine Rechnungen mit der angegebenen Rechnungsnummer vorhanden.", "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Exit Sub
                Else
                    m_SuchSuppress = True
                    SetSucheinschraenkung(False)
                    Me.AdresseinschraenkungTextBox.Text = "Rechnung " & RechnungsNr & " suchen"

                    ListViewAdressAuswahl.BeginUpdate()
                    ListViewAdressAuswahl.Items.Clear()
                    ListViewAdressAuswahl.Items.AddRange(TmpListe.ToArray)

                    ListViewAdressAuswahl.EndUpdate()

                    m_SuchSuppress = False


                    ListViewAdressAuswahl.Items(0).Selected = True
                    ListViewAdressAuswahl.Items(0).EnsureVisible()

                    SetSucheinschraenkung(True)
                End If


            End If
        End If
    End Sub
    Private Sub ListViewNeuFllen()

        If m_UnSortedFlag Then
            m_Items.Sort(New AdressLVIComparer)
            m_UnSortedFlag = False
        End If

        ListViewAdressAuswahl.BeginUpdate()
        ListViewAdressAuswahl.Items.Clear()
        ListViewAdressAuswahl.Items.AddRange(m_Items.ToArray)
        ListViewAdressAuswahl.EndUpdate()
    End Sub
    Private Sub ListViewNeuFllen(ByVal Suchtext As String)

        If m_UnSortedFlag Then
            m_Items.Sort(New AdressLVIComparer)
            m_UnSortedFlag = False
        End If

        Dim Teile() As String = Suchtext.ToLower.Split(" ")
        ListViewAdressAuswahl.BeginUpdate()
        ListViewAdressAuswahl.Items.Clear()
        Dim Gef As Boolean

        For Each LVI As AdressListViewItem In m_Items
            Gef = True
            For Each txt As String In Teile
                If LVI.Text.ToLower.IndexOf(txt) = -1 Then
                    Gef = False
                    Exit For
                End If
            Next
            If Gef Then
                Me.ListViewAdressAuswahl.Items.Add(LVI)
            End If
        Next
        ListViewAdressAuswahl.EndUpdate()
    End Sub

    Private Sub ButtonAlleAnzeigen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAlleAnzeigen.Click
        Me.AdresseinschraenkungTextBox.Text = ""
    End Sub
    Private Sub m_Adressliste_ElementAdded(ByVal AddedElement As Adresse) Handles m_Adressliste.ElementAdded
        If Me.AdresseinschraenkungTextBox.Text.Trim <> "" Then
            Me.AdresseinschraenkungTextBox.Text = ""
        End If
        Dim LVI As New AdressListViewItem(AddedElement)
        m_Items.Add(LVI)
        ListViewAdressAuswahl.Items.Insert(0, LVI)
        m_UnSortedFlag = True
        LVI.EnsureVisible()
    End Sub
    Private Sub m_Adressliste_ElementRemoved(ByVal RemovedElement As Adresse) Handles m_Adressliste.ElementRemoved
        If Me.AdresseinschraenkungTextBox.Text.Trim <> "" Then
            Me.AdresseinschraenkungTextBox.Text = ""
        End If
        For Each LVI As AdressListViewItem In m_Items
            If LVI.Adresse Is RemovedElement Then
                m_Items.Remove(LVI)
                ListViewAdressAuswahl.Items.Remove(LVI)
                Exit For
            End If
        Next
    End Sub

 
    Private Sub m_Adressliste_ElementSelectedChanged(ByVal NewSelectedElement As Adresse, ByVal Sender As Object) Handles m_Adressliste.ElementSelectedChanged
        If Not Sender Is Me Then
            If Me.AdresseinschraenkungTextBox.Text.Trim <> "" Then
                Me.AdresseinschraenkungTextBox.Text = ""
            End If
            For Each LVI As AdressListViewItem In ListViewAdressAuswahl.Items
                If LVI.Adresse Is NewSelectedElement Then
                    LVI.Selected = True
                    LVI.EnsureVisible()
                    Exit For
                End If
            Next

        End If
    End Sub


    Private Sub m_SelectedLVI_TextChanged() Handles m_SelectedLVI.TextChanged
        m_UnSortedFlag = True
    End Sub
    '    Private Sub ListViewAdressAuswahl_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewAdressAuswahl.SizeChanged
    '        Me.ListViewAdressAuswahl.Columns(0).Width = ListViewAdressAuswahl.Width - 22
    '    End Sub


    Private Sub Adessauswaehler_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Me.ListViewAdressAuswahl.Columns(0).Width = ListViewAdressAuswahl.Width - 22
    End Sub
End Class
