Imports Microsoft.Office.Interop
Public Class WordFunktionen
    Public Function DateinameSonderzeichenErsetzen(ByVal Ausgang As String) As String
        Dim Erg As String = Ausgang.Trim
        Erg = Erg.Replace("\", "")
        Erg = Erg.Replace("/", "")
        Erg = Erg.Replace(":", "")
        Erg = Erg.Replace("*", "")
        Erg = Erg.Replace("?", "")
        Erg = Erg.Replace(Chr(34), "")
        Erg = Erg.Replace("<", "")
        Erg = Erg.Replace(">", "")
        Erg = Erg.Replace("|", "")
        Return Erg
    End Function

    Public Function Word_Brief_Erstellen(ByVal Adr As Arbeitsadresse, ByVal Brf As Brief, ByVal BriefeDir As String, ByVal VorlagenDir As String) As Boolean

        Dim Word_LiefSchon As Boolean = False
        Dim Document_LiefSchon As Boolean = False
        Dim WdApp As Word.Application = Nothing
        Dim WdDoc As Word.Document = Nothing

        Dim DokumentPfad As String = BriefeDir & "\" & Brf.Pfad & ".doc"
        Dim VorlagePfad As String = VorlagenDir & "\" & Adr.Dokumentenvorlage & ".dot"

        Try
            WdApp = GetObject(, "Word.Application")
            Word_LiefSchon = True
        Catch ex As Exception
            Try
                WdApp = CreateObject("Word.Application")
            Catch ex1 As Exception

            End Try
        End Try

        Try

            If Word_LiefSchon Then
                For Each Doc As Word.Document In WdApp.Documents
                    Dim DocPfad As String = Doc.Path & "\" & Doc.Name & ".doc"
                    'If DokumentPfad.ToLower.StartsWith(DocPfad.ToLower) Then
                    'nderung wegen *.docx
                    If DocPfad.ToLower = DokumentPfad.ToLower Then
                        WdDoc = Doc
                        Document_LiefSchon = True
                        Exit For
                    End If
                Next
            End If

            If Document_LiefSchon Then
                WdDoc.Activate()
            Else
                WdDoc = WdApp.Documents.Add(Template:=VorlagePfad)
                WdDoc.Activate()
            End If
            WdDoc.Application.Visible = True
            WdDoc.Application.Activate()

            Dim BM As Word.Bookmark
            For I As Integer = 1 To WdDoc.Bookmarks.Count
                BM = WdDoc.Bookmarks.Item(I)
                Select Case BM.Name
                    Case "Anschrift"
                        BM.Range.Text = Adr.AnschriftOben.Trim
                    Case "Datum"
                        BM.Range.Text = Brf.Datum.ToShortDateString
                    Case "Anrede"
                        BM.Range.Text = Adr.Briefanrede
                    Case "Betreff"
                        If Adr.Betreff.Trim <> "" Then
                            BM.Range.Text = Adr.Betreff.Trim & vbCrLf & Brf.Betreff
                        Else
                            BM.Range.Text = Brf.Betreff
                        End If
                    Case "Brieftext"
                        WdApp.Selection.GoTo(What:=Word.WdGoToItem.wdGoToBookmark, Name:="Brieftext")
                End Select
            Next

            WdDoc.SaveAs(DokumentPfad)
            Return True
        Catch ex As Exception
            MessageBox.Show("Fehler beim Erstellen eines Word-Dokuments:" & vbCrLf & ex.Message, "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        Finally
            'Try
            '    If Not Document_LiefSchon Then
            '        WdDoc.Close(Word.WdSaveOptions.wdDoNotSaveChanges)
            '    End If
            '    If Not Word_LiefSchon Then
            '        WdApp.Quit()
            '    End If
            'Catch ex As Exception

            'End Try
            If Not WdApp Is Nothing Then
                System.Runtime.InteropServices.Marshal.ReleaseComObject(WdDoc)
                System.Runtime.InteropServices.Marshal.ReleaseComObject(WdApp)
            End If
            GC.Collect()
        End Try
    End Function

    Public Function Dok_VorlageErstellen(ByVal VorlagenName As String, ByVal VorlagenDir As String) As Boolean

        Dim AppName As String = "Briefdatenbank"
        VorlagenName = VorlagenName.Trim

        If VorlagenName.ToLower = "autobrief" Then
            MessageBox.Show("Der Name " & Chr(34) & VorlagenName & Chr(34) & " ist fr Briefdatenbank-Dokumentenvorlagen nicht erlaubt.", AppName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        End If

        'Dim Word_LiefSchon As Boolean = False
        Dim WdApp As Word.Application = Nothing
        Dim WdDoc As Word.Document = Nothing

        Try
            WdApp = GetObject(, "Word.Application")
            MessageBox.Show("Eine Dokumentenvorlage kann nur erstellt oder bearbeitet werden, wenn Microsoft Word geschlossen ist." & vbCrLf & "Bitte schlieen Sie alle Word-Fenster.", AppName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            System.Runtime.InteropServices.Marshal.ReleaseComObject(WdApp)
            Return False
        Catch ex As Exception
            Try
                WdApp = CreateObject("Word.Application")
            Catch ex1 As Exception

            End Try
        End Try


        Dim VorlagenPfad As String = VorlagenDir & "\" & VorlagenName & ".dot"

        If IO.File.Exists(VorlagenPfad) Then
            If MessageBox.Show("Die Dokumentenvorlage " & Chr(34) & VorlagenName & Chr(34) & " existiert schon." & vbCrLf & "Soll diese Vorlage berschrieben werden?", AppName, MessageBoxButtons.YesNo, MessageBoxIcon.Information) = DialogResult.Yes Then
                Try
                    IO.File.Delete(VorlagenPfad)
                Catch ex As Exception
                    MessageBox.Show("Fehler beim Erstellen einer Word-Dokumentenvorlage:" & vbCrLf & ex.Message, "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Return False
                End Try
            Else
                Return False
            End If
        End If


        Dim AD As New AbsenderDaten(VorlagenDir & "\Absender.xml")
        Dim frmV As New frm_Absenderdaten_Bearbeiten(AD)
        If frmV.ShowDialog <> DialogResult.OK Then
            Return False
        End If

        AD.Speichern(VorlagenDir & "\Absender.xml")

        Try
            IO.File.Copy(Application.StartupPath & "\Autobrief.dot", VorlagenPfad, False)
        Catch ex As Exception
            MessageBox.Show("Fehler beim Erstellen einer Word-Dokumentenvorlage:" & vbCrLf & ex.Message, "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        End Try



        Try


            WdApp.ChangeFileOpenDirectory(VorlagenDir)

            WdDoc = WdApp.Documents.Open(FileName:=VorlagenName & ".dot", ConfirmConversions:=False, ReadOnly _
                             :=False, AddToRecentFiles:=False, PasswordDocument:="", PasswordTemplate _
                             :="", Revert:=False, WritePasswordDocument:="", WritePasswordTemplate:="" _
                             , Format:=Word.WdOpenFormat.wdOpenFormatAuto)
            WdApp.Visible = True

            Dim BM As Word.Bookmark
            For I As Integer = 1 To WdDoc.Bookmarks.Count
                BM = WdDoc.Bookmarks.Item(I)
                Select Case BM.Name
                    Case "xa"
                        BM.Range.Text = AD.Vorname
                    Case "xb"
                        BM.Range.Text = AD.Nachname
                    Case "xc"
                        BM.Range.Text = AD.Strasse
                    Case "xd"
                        BM.Range.Text = AD.PLZ
                    Case "xe"
                        BM.Range.Text = AD.Ort
                    Case "xf"
                        If AD.Telefon <> "" Then
                            BM.Range.Text = AD.Telefon
                        End If
                    Case "xg"
                        If AD.Telefon1 <> "" Then
                            BM.Range.Text = AD.Telefon1
                        End If
                    Case "ya"
                        BM.Range.Text = AD.Vorname
                    Case "yb"
                        BM.Range.Text = AD.Nachname
                    Case "yc"
                        BM.Range.Text = AD.Strasse
                    Case "yd"
                        BM.Range.Text = AD.PLZ
                    Case "ye"
                        BM.Range.Text = AD.Ort
                    Case "ze"
                        BM.Range.Text = AD.Ort
                    Case "za"
                        BM.Range.Text = AD.Vorname
                    Case "zb"
                        BM.Range.Text = AD.Nachname
                End Select
            Next

            WdDoc.Save()
            Return True
        Catch ex As Exception
            MessageBox.Show("Fehler beim Erstellen einer Word-Dokumentenvorlage:" & vbCrLf & ex.Message, "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        Finally
            WdDoc.Close(Word.WdSaveOptions.wdDoNotSaveChanges)
            WdApp.Quit()
            If Not WdApp Is Nothing Then
                System.Runtime.InteropServices.Marshal.ReleaseComObject(WdDoc)
                System.Runtime.InteropServices.Marshal.ReleaseComObject(WdApp)
            End If
            GC.Collect()
        End Try

    End Function
    Public Function Word_Dokument_Oeffnen(ByVal Pfad As String) As Boolean
        Dim AppName As String = "Briefdatenbank"
        If Not IO.File.Exists(Pfad) Then
            MessageBox.Show("Fehler beim ffnen eines Word-Dokuments:" & vbCrLf & "Unter dem genannten Pfad existiert keine Datei.", AppName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        End If

        Dim Word_LiefSchon As Boolean = False
        Dim WdApp As Word.Application = Nothing
        Dim WdDoc As Word.Document = Nothing


        Try
            WdApp = GetObject(, "Word.Application")
            Word_LiefSchon = True
        Catch ex As Exception
            Try
                WdApp = CreateObject("Word.Application")
            Catch ex1 As Exception

            End Try
        End Try

        Try

            If Word_LiefSchon Then
                For Each Doc As Word.Document In WdApp.Documents
                    Dim DocPfad As String = Doc.Path & "\" & Doc.Name & ".doc"
                    'If Pfad.ToLower.StartsWith(DocPfad.ToLower) Then
                    If DocPfad.ToLower = Pfad.ToLower Then
                        WdDoc = Doc
                        Exit For
                    End If
                Next
            End If


            If WdDoc IsNot Nothing Then
                WdDoc.Activate()
            Else
                WdDoc = WdApp.Documents.Open(Pfad)
                WdDoc.Activate()
            End If
            WdDoc.Application.Visible = True
            WdDoc.Application.Activate()

            Return True
        Catch ex As Exception
            MessageBox.Show("Fehler beim ffnen eines Word-Dokuments:" & vbCrLf & ex.Message, "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        Finally
            'Try
            '    If Not Document_LiefSchon Then
            '        WdDoc.Close(Word.WdSaveOptions.wdDoNotSaveChanges)
            '    End If
            '    If Not Word_LiefSchon Then
            '        WdApp.Quit()
            '    End If
            'Catch ex As Exception

            'End Try
            If Not WdApp Is Nothing Then
                System.Runtime.InteropServices.Marshal.ReleaseComObject(WdDoc)
                System.Runtime.InteropServices.Marshal.ReleaseComObject(WdApp)
            End If

        End Try

    End Function

    Public Function Word_Plugin_Brief_Erstellen(ByVal Adr As Arbeitsadresse, ByVal DokumentPfad As String, ByVal VorlagenDir As String, _
    ByVal Result As Briefdatenbank.Plugin.Common.PlugInResult) As Boolean

        Dim Word_LiefSchon As Boolean = False
        Dim Document_LiefSchon As Boolean = False
        Dim WdApp As Word.Application = Nothing
        Dim WdDoc As Word.Document = Nothing
        Dim oDocBuiltInProps As Object = Nothing
        Dim oDocCustomProps As Object = Nothing

        'Dim DokumentPfad As String = BriefeDir & "\" & Brf.Pfad & ".doc"
        Dim VorlagePfad As String = VorlagenDir & "\" & Adr.Dokumentenvorlage & ".dot"


        Try
            WdApp = GetObject(, "Word.Application")
            Word_LiefSchon = True
        Catch ex As Exception
            Try
                WdApp = CreateObject("Word.Application")
            Catch ex1 As Exception

            End Try
        End Try

        Try
            If Word_LiefSchon Then
                For Each Doc As Word.Document In WdApp.Documents
                    Dim DocPfad As String = Doc.Path & "\" & Doc.Name & ".doc"
                    'If DokumentPfad.ToLower.StartsWith(DocPfad.ToLower) Then
                    If DocPfad.ToLower = DokumentPfad.ToLower Then
                        WdDoc = Doc
                        Document_LiefSchon = True
                        Exit For
                    End If
                Next
            End If

            If Document_LiefSchon Then
                WdDoc.Activate()
            Else
                WdDoc = WdApp.Documents.Add(Template:=VorlagePfad)
                WdDoc.Activate()
            End If
            WdDoc.Application.Visible = True
            WdDoc.Application.Activate()


            For Each APar As Word.Paragraph In WdDoc.Paragraphs
                APar.Hyphenation = False
            Next

            Dim BM As Word.Bookmark
            For I As Integer = 1 To WdDoc.Bookmarks.Count
                BM = WdDoc.Bookmarks.Item(I)
                Select Case BM.Name
                    Case "Anschrift"
                        BM.Range.Text = Adr.AnschriftOben.Trim
                    Case "Datum"
                        BM.Range.Text = Result.Datum.ToShortDateString
                    Case "Anrede"
                        BM.Range.Text = Adr.Briefanrede
                    Case "Betreff"
                        If Adr.Betreff.Trim <> "" Then
                            BM.Range.Text = Adr.Betreff.Trim & vbCrLf & Result.BetreffText
                        Else
                            BM.Range.Text = Result.BetreffText
                        End If
                    Case "Brieftext"
                        Dim ActRng As Word.Range = BM.Range
                        ActRng.Collapse(Word.WdCollapseDirection.wdCollapseStart)
                        Dim NextItemIsTable As Boolean = False

                        Dim TestTable As New Briefdatenbank.Plugin.Common.Table(1, 1)

                        For J As Integer = 0 To Result.Liste_Texte.Count - 1
                            NextItemIsTable = False
                            If J < Result.Liste_Texte.Count - 1 Then
                                Dim o1 As Object = Result.Liste_Texte.Item(J + 1)
                                If o1.GetType Is TestTable.GetType Then
                                    NextItemIsTable = True
                                End If
                            End If

                            Dim o As Object = Result.Liste_Texte.Item(J)

                            If o.GetType Is TestTable.GetType Then
                                Dim oTbl As Briefdatenbank.Plugin.Common.Table = o

                                ActRng.Collapse(Word.WdCollapseDirection.wdCollapseStart)

                                Dim Tbl As Word.Table = WdDoc.Tables.Add(ActRng, oTbl.NumRows, oTbl.NumColumns)
                                Tbl.Rows.Alignment = WdTableAlignment_Liefern(oTbl.Alignment)
                                Tbl.Range.ParagraphFormat.SpaceBefore = CSng(0)
                                Tbl.Borders.InsideLineStyle = Word.WdLineStyle.wdLineStyleNone
                                Tbl.Borders.OutsideLineStyle = Word.WdLineStyle.wdLineStyleNone
                                ActRng = Tbl.Range
                                ActRng.Collapse(Word.WdCollapseDirection.wdCollapseEnd)

                                For K As Integer = 0 To oTbl.NumRows - 1
                                    For L As Integer = 0 To oTbl.NumColumns - 1
                                        CellValuesSetzen(Tbl.Cell(K + 1, L + 1), oTbl.Cells(K, L))
                                    Next
                                Next
                                Tbl.AutoFitBehavior(Word.WdAutoFitBehavior.wdAutoFitContent)
                                If Tbl.Cell(1, oTbl.NumColumns).Range.Text.StartsWith("Betrag") Then
                                    Tbl.Columns.Item(oTbl.NumColumns).PreferredWidthType = Word.WdPreferredWidthType.wdPreferredWidthPoints
                                    Tbl.Columns.Item(oTbl.NumColumns).PreferredWidth = WdApp.CentimetersToPoints(2)
                                End If
                                Tbl.Range.ParagraphFormat.Hyphenation = False

                            Else
                                Dim xPar As Briefdatenbank.Plugin.Common.TextParagraph = o

                                Dim MRng As Word.Range
                                ActRng.Collapse(Word.WdCollapseDirection.wdCollapseStart)
                                'ActRng.Text = "Text" & J.ToString
                                RangeText_Festlegen(ActRng, xPar)
                                MRng = ActRng
                                ActRng.Collapse(Word.WdCollapseDirection.wdCollapseEnd)
                                Dim Par As Word.Paragraph = WdDoc.Paragraphs.Add(ActRng)
                                ActRng = Par.Range
                                ActRng.Collapse(Word.WdCollapseDirection.wdCollapseEnd)

                                MRng.Paragraphs.Item(1).Alignment = WdParagraphAlignment_Liefern(xPar.Alignment)
                                If xPar.Alignment = Plugin.Common.ParagraphAlignments.Block Then
                                    MRng.Paragraphs.Item(1).Hyphenation = True
                                Else
                                    MRng.Paragraphs.Item(1).Hyphenation = False
                                End If

                                If NextItemIsTable Then
                                    MRng.Paragraphs.Item(1).Format.SpaceAfter = 6
                                End If

                            End If
                        Next

                        ActRng.Paragraphs.Item(ActRng.Paragraphs.Count).Range.Delete()

                        WdApp.Selection.GoTo(What:=Word.WdGoToItem.wdGoToBookmark, Name:="Brieftext")

                End Select
            Next

            WdDoc.HyphenationZone = 18
            WdDoc.HyphenateCaps = False
            WdDoc.ConsecutiveHyphensLimit = 2

            WdDoc.AutoHyphenation = True


            Dim Liste As New List(Of EigenesDocumentProperty)
            Dim oDocCustomProp As Object
            'Dim typeDocCustomProp As Type

            For Each O As Object In WdDoc.CustomDocumentProperties
                Dim Name As String = O.Name.ToString

                If Name.StartsWith("BDB") Then
                    If Name.Length > 3 Then
                        Dim Nr As String = Name.Substring(3)
                        If IsNumeric(Nr) Then
                            Try
                                Dim Ziffer As Integer = CInt(Nr)
                                'oDocCustomProp = O
                                'typeDocCustomProp = oDocCustomProp.GetType
                                Dim Werta As String = O.Value.ToString
                                Liste.Add(New EigenesDocumentProperty(Ziffer, Werta, Name))
                            Catch ex As Exception

                            End Try
                        End If
                    End If
                End If
            Next

            For Each Prop As EigenesDocumentProperty In Liste
                oDocCustomProp = WdDoc.CustomDocumentProperties(Prop.Name)
                oDocCustomProp.Delete()
            Next

            Liste.Clear()
            Dim RestText As String = Result.PersistText
            Dim Zaehler As Integer = 1

            While RestText <> ""
                If RestText.Length > 255 Then
                    Liste.Add(New EigenesDocumentProperty(Zaehler, RestText.Substring(0, 255), "BDB" & Zaehler.ToString))
                    RestText = RestText.Substring(255)
                Else
                    Liste.Add(New EigenesDocumentProperty(Zaehler, RestText, "BDB" & Zaehler.ToString))
                    RestText = ""
                End If
                Zaehler += 1
            End While


            oDocBuiltInProps = WdDoc.BuiltInDocumentProperties

            'Add a property/value pair to the CustomDocumentProperties collection.
            oDocCustomProps = WdDoc.CustomDocumentProperties
            Dim typeDocCustomProps As Type = oDocCustomProps.GetType()

            For Each Prop As EigenesDocumentProperty In Liste
                Dim oArgs As Object() = {Prop.Name, False, Microsoft.Office.Core.MsoDocProperties.msoPropertyTypeString, Prop.Text}
                typeDocCustomProps.InvokeMember("Add", Reflection.BindingFlags.Default Or Reflection.BindingFlags.InvokeMethod, Nothing, oDocCustomProps, oArgs)
            Next


            'Dim oArgs As Object() = {"BDB11", False, Office.MsoDocProperties.msoPropertyTypeString, Wert}
            'typeDocCustomProps.InvokeMember("Add", Reflection.BindingFlags.Default Or Reflection.BindingFlags.InvokeMethod, Nothing, oDocCustomProps, oArgs)


            'Boolean = 2
            'Date = 3
            'Float = 5
            'Number =1
            'String =4



            WdDoc.SaveAs(DokumentPfad)
            Return True


        Catch ex As Exception
            MessageBox.Show("Fehler beim Erstellen eines Word-Dokuments:" & vbCrLf & ex.Message, "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return False
        Finally
            If Not WdApp Is Nothing Then
                If oDocBuiltInProps IsNot Nothing Then System.Runtime.InteropServices.Marshal.ReleaseComObject(oDocBuiltInProps)
                If oDocCustomProps IsNot Nothing Then System.Runtime.InteropServices.Marshal.ReleaseComObject(oDocCustomProps)
                System.Runtime.InteropServices.Marshal.ReleaseComObject(WdDoc)
                System.Runtime.InteropServices.Marshal.ReleaseComObject(WdApp)
                oDocBuiltInProps = Nothing
                oDocCustomProps = Nothing
                WdDoc = Nothing
                WdApp = Nothing

            End If
            GC.Collect()
        End Try



    End Function

    Public Function ReadProperties(ByVal DokumentPfad As String) As String

        Dim ZStr As String = ""

        Dim Word_LiefSchon As Boolean = False
        Dim Document_LiefSchon As Boolean = False
        Dim WdApp As Word.Application = Nothing
        Dim WdDoc As Word.Document = Nothing

        Try
            WdApp = GetObject(, "Word.Application")
            Word_LiefSchon = True
        Catch ex As Exception
            Try
                WdApp = CreateObject("Word.Application")
            Catch ex1 As Exception

            End Try
        End Try

        Try
            If Word_LiefSchon Then
                For Each Doc As Word.Document In WdApp.Documents
                    Dim DocPfad As String = Doc.Path & "\" & Doc.Name & ".doc"
                    'If DokumentPfad.ToLower.StartsWith(DocPfad.ToLower) Then
                    If DocPfad.ToLower = DokumentPfad.ToLower Then
                        WdDoc = Doc
                        Document_LiefSchon = True
                        Exit For
                    End If
                Next
            End If

            If Not Document_LiefSchon Then
                WdDoc = WdApp.Documents.Open(DokumentPfad)
            End If

            Dim Liste As New List(Of EigenesDocumentProperty)

            'Dim Zaehler As Integer = 1
            For Each O As Object In WdDoc.CustomDocumentProperties
                Dim Name As String = O.Name.ToString

                If Name.StartsWith("BDB") Then
                    If Name.Length > 3 Then
                        Dim Nr As String = Name.Substring(3)
                        If IsNumeric(Nr) Then
                            Try
                                Dim Ziffer As Integer = CInt(Nr)
                                Dim Wert As String = O.Value.ToString
                                Liste.Add(New EigenesDocumentProperty(Ziffer, Wert, Name))
                            Catch ex As Exception

                            End Try
                        End If
                    End If
                End If

            Next

            Liste.Sort(New EigenesDocumentPropertyComparer)


            For Each obj As EigenesDocumentProperty In Liste
                ZStr &= obj.Text
            Next



            'Boolean = 2
            'Date = 3
            'Float = 5
            'Number =1
            'String =4


            If Not Document_LiefSchon Then
                WdDoc.Close(Word.WdSaveOptions.wdDoNotSaveChanges)
            End If

            If Not Word_LiefSchon Then
                WdApp.Quit()
            End If
            Return ZStr
        Catch ex As Exception
            MessageBox.Show("Fehler beim Lesen eines Word-Dokuments:" & vbCrLf & ex.Message, "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return ""
        Finally
            If Not WdApp Is Nothing Then
                System.Runtime.InteropServices.Marshal.ReleaseComObject(WdDoc)
                System.Runtime.InteropServices.Marshal.ReleaseComObject(WdApp)
            End If
            GC.Collect()
        End Try

    End Function

#Region " Extrafunktionen "
    Private Function WdParagraphAlignment_Liefern(ByVal Alignment As Briefdatenbank.Plugin.Common.ParagraphAlignments) As Word.WdParagraphAlignment
        Select Case Alignment
            Case Plugin.Common.ParagraphAlignments.Block
                Return Word.WdParagraphAlignment.wdAlignParagraphJustify
            Case Plugin.Common.ParagraphAlignments.Center
                Return Word.WdParagraphAlignment.wdAlignParagraphCenter
            Case Plugin.Common.ParagraphAlignments.Left
                Return Word.WdParagraphAlignment.wdAlignParagraphLeft
            Case Plugin.Common.ParagraphAlignments.Right
                Return Word.WdParagraphAlignment.wdAlignParagraphRight
        End Select
    End Function
    Private Function WdTableAlignment_Liefern(ByVal Alignment As Briefdatenbank.Plugin.Common.ParagraphAlignments) As Word.WdRowAlignment
        Select Case Alignment
            Case Plugin.Common.ParagraphAlignments.Block
                Return Word.WdRowAlignment.wdAlignRowCenter
            Case Plugin.Common.ParagraphAlignments.Center
                Return Word.WdRowAlignment.wdAlignRowCenter
            Case Plugin.Common.ParagraphAlignments.Left
                Return Word.WdRowAlignment.wdAlignRowLeft
            Case Plugin.Common.ParagraphAlignments.Right
                Return Word.WdRowAlignment.wdAlignRowRight
        End Select
    End Function
    Private Sub CellValuesSetzen(ByVal Cl As Word.Cell, ByVal TabCl As Briefdatenbank.Plugin.Common.TableCell)
        Select Case TabCl.Paragraph.Alignment
            Case Plugin.Common.ParagraphAlignments.Block
                Cl.Range.ParagraphFormat.Alignment = Word.WdParagraphAlignment.wdAlignParagraphJustify
            Case Plugin.Common.ParagraphAlignments.Center
                Cl.Range.ParagraphFormat.Alignment = Word.WdParagraphAlignment.wdAlignParagraphCenter
            Case Plugin.Common.ParagraphAlignments.Left
                Cl.Range.ParagraphFormat.Alignment = Word.WdParagraphAlignment.wdAlignParagraphLeft
            Case Plugin.Common.ParagraphAlignments.Right
                Cl.Range.ParagraphFormat.Alignment = Word.WdParagraphAlignment.wdAlignParagraphRight
        End Select
        Select Case TabCl.VerticalAlignment
            Case Plugin.Common.TableCellVerticalAlignments.Top
                Cl.VerticalAlignment = Word.WdCellVerticalAlignment.wdCellAlignVerticalTop
            Case Plugin.Common.TableCellVerticalAlignments.Center
                Cl.VerticalAlignment = Word.WdCellVerticalAlignment.wdCellAlignVerticalCenter
            Case Plugin.Common.TableCellVerticalAlignments.Bottom
                Cl.VerticalAlignment = Word.WdCellVerticalAlignment.wdCellAlignVerticalBottom
        End Select


        If TabCl.Borders.TopBorder = Plugin.Common.TableCellBorderStyles.Einfach Then
            Cl.Borders.Item(Word.WdBorderType.wdBorderTop).LineStyle = Word.WdLineStyle.wdLineStyleSingle
        End If
        If TabCl.Borders.BottomBorder = Plugin.Common.TableCellBorderStyles.Einfach Then
            Cl.Borders.Item(Word.WdBorderType.wdBorderBottom).LineStyle = Word.WdLineStyle.wdLineStyleSingle
        End If
        If TabCl.Borders.LeftBorder = Plugin.Common.TableCellBorderStyles.Einfach Then
            Cl.Borders.Item(Word.WdBorderType.wdBorderLeft).LineStyle = Word.WdLineStyle.wdLineStyleSingle
        End If
        If TabCl.Borders.RightBorder = Plugin.Common.TableCellBorderStyles.Einfach Then
            Cl.Borders.Item(Word.WdBorderType.wdBorderRight).LineStyle = Word.WdLineStyle.wdLineStyleSingle
        End If


        If TabCl.Borders.TopBorder = Plugin.Common.TableCellBorderStyles.Doppelt Then
            Cl.Borders.Item(Word.WdBorderType.wdBorderTop).LineStyle = Word.WdLineStyle.wdLineStyleDouble
        End If
        If TabCl.Borders.BottomBorder = Plugin.Common.TableCellBorderStyles.Doppelt Then
            Cl.Borders.Item(Word.WdBorderType.wdBorderBottom).LineStyle = Word.WdLineStyle.wdLineStyleDouble
        End If
        If TabCl.Borders.LeftBorder = Plugin.Common.TableCellBorderStyles.Doppelt Then
            Cl.Borders.Item(Word.WdBorderType.wdBorderLeft).LineStyle = Word.WdLineStyle.wdLineStyleDouble
        End If
        If TabCl.Borders.RightBorder = Plugin.Common.TableCellBorderStyles.Doppelt Then
            Cl.Borders.Item(Word.WdBorderType.wdBorderRight).LineStyle = Word.WdLineStyle.wdLineStyleDouble
        End If

        RangeText_Festlegen(Cl.Range, TabCl.Paragraph)
    End Sub
    Private Sub RangeText_Festlegen(ByVal Rng As Word.Range, ByVal Par As Briefdatenbank.Plugin.Common.TextParagraph)
        Dim NotFirst As Boolean = False
        For Each TE As Briefdatenbank.Plugin.Common.TextEintrag In Par.TextEintraege
            If NotFirst Then
                Rng.Collapse(Word.WdCollapseDirection.wdCollapseEnd)
                If (TE.Text.StartsWith(",")) Or (TE.Text.StartsWith(".")) Then
                    Rng.Text = TE.Text
                Else
                    Rng.Text = " " & TE.Text
                End If
            Else
                Rng.Text = TE.Text
            End If
            If TE.Format = Plugin.Common.TextFormats.Normal Then
                Rng.Font.Bold = False
                Rng.Font.Italic = False
            ElseIf TE.Format = Plugin.Common.TextFormats.Bold Then
                Rng.Font.Bold = True
                Rng.Font.Italic = False
            ElseIf TE.Format = Plugin.Common.TextFormats.Kursiv Then
                Rng.Font.Bold = False
                Rng.Font.Italic = True
            ElseIf TE.Format = Plugin.Common.TextFormats.BoldKursiv Then
                Rng.Font.Bold = True
                Rng.Font.Italic = True
            End If


            NotFirst = True
        Next

    End Sub

#End Region
End Class
